(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('crypto')) :
  typeof define === 'function' && define.amd ? define(['exports', 'rxjs', 'crypto'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.ReactRedux = {}, global.rxjs, global.crypto));
})(this, (function (exports, rxjs, crypto) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var crypto__default = /*#__PURE__*/_interopDefaultLegacy(crypto);

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  /*! *****************************************************************************
  Copyright (c) Microsoft Corporation.

  Permission to use, copy, modify, and/or distribute this software for any
  purpose with or without fee is hereby granted.

  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
  REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
  AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
  INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
  PERFORMANCE OF THIS SOFTWARE.
  ***************************************************************************** */
  /* global Reflect, Promise */

  var extendStatics = function(d, b) {
      extendStatics = Object.setPrototypeOf ||
          ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
          function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
      return extendStatics(d, b);
  };

  function __extends(d, b) {
      extendStatics(d, b);
      function __() { this.constructor = d; }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  }

  /** PURE_IMPORTS_START  PURE_IMPORTS_END */
  function isFunction(x) {
      return typeof x === 'function';
  }

  /** PURE_IMPORTS_START  PURE_IMPORTS_END */
  var _enable_super_gross_mode_that_will_cause_bad_things = false;
  var config = {
      Promise: undefined,
      set useDeprecatedSynchronousErrorHandling(value) {
          if (value) {
              var error = /*@__PURE__*/ new Error();
              /*@__PURE__*/ console.warn('DEPRECATED! RxJS was set to use deprecated synchronous error handling behavior by code at: \n' + error.stack);
          }
          _enable_super_gross_mode_that_will_cause_bad_things = value;
      },
      get useDeprecatedSynchronousErrorHandling() {
          return _enable_super_gross_mode_that_will_cause_bad_things;
      },
  };

  /** PURE_IMPORTS_START  PURE_IMPORTS_END */
  function hostReportError(err) {
      setTimeout(function () { throw err; }, 0);
  }

  /** PURE_IMPORTS_START _config,_util_hostReportError PURE_IMPORTS_END */
  var empty$1 = {
      closed: true,
      next: function (value) { },
      error: function (err) {
          if (config.useDeprecatedSynchronousErrorHandling) {
              throw err;
          }
          else {
              hostReportError(err);
          }
      },
      complete: function () { }
  };

  /** PURE_IMPORTS_START  PURE_IMPORTS_END */
  var isArray = /*@__PURE__*/ (function () { return Array.isArray || (function (x) { return x && typeof x.length === 'number'; }); })();

  /** PURE_IMPORTS_START  PURE_IMPORTS_END */
  function isObject(x) {
      return x !== null && typeof x === 'object';
  }

  /** PURE_IMPORTS_START  PURE_IMPORTS_END */
  var UnsubscriptionErrorImpl = /*@__PURE__*/ (function () {
      function UnsubscriptionErrorImpl(errors) {
          Error.call(this);
          this.message = errors ?
              errors.length + " errors occurred during unsubscription:\n" + errors.map(function (err, i) { return i + 1 + ") " + err.toString(); }).join('\n  ') : '';
          this.name = 'UnsubscriptionError';
          this.errors = errors;
          return this;
      }
      UnsubscriptionErrorImpl.prototype = /*@__PURE__*/ Object.create(Error.prototype);
      return UnsubscriptionErrorImpl;
  })();
  var UnsubscriptionError = UnsubscriptionErrorImpl;

  /** PURE_IMPORTS_START _util_isArray,_util_isObject,_util_isFunction,_util_UnsubscriptionError PURE_IMPORTS_END */
  var Subscription = /*@__PURE__*/ (function () {
      function Subscription(unsubscribe) {
          this.closed = false;
          this._parentOrParents = null;
          this._subscriptions = null;
          if (unsubscribe) {
              this._ctorUnsubscribe = true;
              this._unsubscribe = unsubscribe;
          }
      }
      Subscription.prototype.unsubscribe = function () {
          var errors;
          if (this.closed) {
              return;
          }
          var _a = this, _parentOrParents = _a._parentOrParents, _ctorUnsubscribe = _a._ctorUnsubscribe, _unsubscribe = _a._unsubscribe, _subscriptions = _a._subscriptions;
          this.closed = true;
          this._parentOrParents = null;
          this._subscriptions = null;
          if (_parentOrParents instanceof Subscription) {
              _parentOrParents.remove(this);
          }
          else if (_parentOrParents !== null) {
              for (var index = 0; index < _parentOrParents.length; ++index) {
                  var parent_1 = _parentOrParents[index];
                  parent_1.remove(this);
              }
          }
          if (isFunction(_unsubscribe)) {
              if (_ctorUnsubscribe) {
                  this._unsubscribe = undefined;
              }
              try {
                  _unsubscribe.call(this);
              }
              catch (e) {
                  errors = e instanceof UnsubscriptionError ? flattenUnsubscriptionErrors(e.errors) : [e];
              }
          }
          if (isArray(_subscriptions)) {
              var index = -1;
              var len = _subscriptions.length;
              while (++index < len) {
                  var sub = _subscriptions[index];
                  if (isObject(sub)) {
                      try {
                          sub.unsubscribe();
                      }
                      catch (e) {
                          errors = errors || [];
                          if (e instanceof UnsubscriptionError) {
                              errors = errors.concat(flattenUnsubscriptionErrors(e.errors));
                          }
                          else {
                              errors.push(e);
                          }
                      }
                  }
              }
          }
          if (errors) {
              throw new UnsubscriptionError(errors);
          }
      };
      Subscription.prototype.add = function (teardown) {
          var subscription = teardown;
          if (!teardown) {
              return Subscription.EMPTY;
          }
          switch (typeof teardown) {
              case 'function':
                  subscription = new Subscription(teardown);
              case 'object':
                  if (subscription === this || subscription.closed || typeof subscription.unsubscribe !== 'function') {
                      return subscription;
                  }
                  else if (this.closed) {
                      subscription.unsubscribe();
                      return subscription;
                  }
                  else if (!(subscription instanceof Subscription)) {
                      var tmp = subscription;
                      subscription = new Subscription();
                      subscription._subscriptions = [tmp];
                  }
                  break;
              default: {
                  throw new Error('unrecognized teardown ' + teardown + ' added to Subscription.');
              }
          }
          var _parentOrParents = subscription._parentOrParents;
          if (_parentOrParents === null) {
              subscription._parentOrParents = this;
          }
          else if (_parentOrParents instanceof Subscription) {
              if (_parentOrParents === this) {
                  return subscription;
              }
              subscription._parentOrParents = [_parentOrParents, this];
          }
          else if (_parentOrParents.indexOf(this) === -1) {
              _parentOrParents.push(this);
          }
          else {
              return subscription;
          }
          var subscriptions = this._subscriptions;
          if (subscriptions === null) {
              this._subscriptions = [subscription];
          }
          else {
              subscriptions.push(subscription);
          }
          return subscription;
      };
      Subscription.prototype.remove = function (subscription) {
          var subscriptions = this._subscriptions;
          if (subscriptions) {
              var subscriptionIndex = subscriptions.indexOf(subscription);
              if (subscriptionIndex !== -1) {
                  subscriptions.splice(subscriptionIndex, 1);
              }
          }
      };
      Subscription.EMPTY = (function (empty) {
          empty.closed = true;
          return empty;
      }(new Subscription()));
      return Subscription;
  }());
  function flattenUnsubscriptionErrors(errors) {
      return errors.reduce(function (errs, err) { return errs.concat((err instanceof UnsubscriptionError) ? err.errors : err); }, []);
  }

  /** PURE_IMPORTS_START  PURE_IMPORTS_END */
  var rxSubscriber = /*@__PURE__*/ (function () {
      return typeof Symbol === 'function'
          ? /*@__PURE__*/ Symbol('rxSubscriber')
          : '@@rxSubscriber_' + /*@__PURE__*/ Math.random();
  })();

  /** PURE_IMPORTS_START tslib,_util_isFunction,_Observer,_Subscription,_internal_symbol_rxSubscriber,_config,_util_hostReportError PURE_IMPORTS_END */
  var Subscriber = /*@__PURE__*/ (function (_super) {
      __extends(Subscriber, _super);
      function Subscriber(destinationOrNext, error, complete) {
          var _this = _super.call(this) || this;
          _this.syncErrorValue = null;
          _this.syncErrorThrown = false;
          _this.syncErrorThrowable = false;
          _this.isStopped = false;
          switch (arguments.length) {
              case 0:
                  _this.destination = empty$1;
                  break;
              case 1:
                  if (!destinationOrNext) {
                      _this.destination = empty$1;
                      break;
                  }
                  if (typeof destinationOrNext === 'object') {
                      if (destinationOrNext instanceof Subscriber) {
                          _this.syncErrorThrowable = destinationOrNext.syncErrorThrowable;
                          _this.destination = destinationOrNext;
                          destinationOrNext.add(_this);
                      }
                      else {
                          _this.syncErrorThrowable = true;
                          _this.destination = new SafeSubscriber(_this, destinationOrNext);
                      }
                      break;
                  }
              default:
                  _this.syncErrorThrowable = true;
                  _this.destination = new SafeSubscriber(_this, destinationOrNext, error, complete);
                  break;
          }
          return _this;
      }
      Subscriber.prototype[rxSubscriber] = function () { return this; };
      Subscriber.create = function (next, error, complete) {
          var subscriber = new Subscriber(next, error, complete);
          subscriber.syncErrorThrowable = false;
          return subscriber;
      };
      Subscriber.prototype.next = function (value) {
          if (!this.isStopped) {
              this._next(value);
          }
      };
      Subscriber.prototype.error = function (err) {
          if (!this.isStopped) {
              this.isStopped = true;
              this._error(err);
          }
      };
      Subscriber.prototype.complete = function () {
          if (!this.isStopped) {
              this.isStopped = true;
              this._complete();
          }
      };
      Subscriber.prototype.unsubscribe = function () {
          if (this.closed) {
              return;
          }
          this.isStopped = true;
          _super.prototype.unsubscribe.call(this);
      };
      Subscriber.prototype._next = function (value) {
          this.destination.next(value);
      };
      Subscriber.prototype._error = function (err) {
          this.destination.error(err);
          this.unsubscribe();
      };
      Subscriber.prototype._complete = function () {
          this.destination.complete();
          this.unsubscribe();
      };
      Subscriber.prototype._unsubscribeAndRecycle = function () {
          var _parentOrParents = this._parentOrParents;
          this._parentOrParents = null;
          this.unsubscribe();
          this.closed = false;
          this.isStopped = false;
          this._parentOrParents = _parentOrParents;
          return this;
      };
      return Subscriber;
  }(Subscription));
  var SafeSubscriber = /*@__PURE__*/ (function (_super) {
      __extends(SafeSubscriber, _super);
      function SafeSubscriber(_parentSubscriber, observerOrNext, error, complete) {
          var _this = _super.call(this) || this;
          _this._parentSubscriber = _parentSubscriber;
          var next;
          var context = _this;
          if (isFunction(observerOrNext)) {
              next = observerOrNext;
          }
          else if (observerOrNext) {
              next = observerOrNext.next;
              error = observerOrNext.error;
              complete = observerOrNext.complete;
              if (observerOrNext !== empty$1) {
                  context = Object.create(observerOrNext);
                  if (isFunction(context.unsubscribe)) {
                      _this.add(context.unsubscribe.bind(context));
                  }
                  context.unsubscribe = _this.unsubscribe.bind(_this);
              }
          }
          _this._context = context;
          _this._next = next;
          _this._error = error;
          _this._complete = complete;
          return _this;
      }
      SafeSubscriber.prototype.next = function (value) {
          if (!this.isStopped && this._next) {
              var _parentSubscriber = this._parentSubscriber;
              if (!config.useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                  this.__tryOrUnsub(this._next, value);
              }
              else if (this.__tryOrSetError(_parentSubscriber, this._next, value)) {
                  this.unsubscribe();
              }
          }
      };
      SafeSubscriber.prototype.error = function (err) {
          if (!this.isStopped) {
              var _parentSubscriber = this._parentSubscriber;
              var useDeprecatedSynchronousErrorHandling = config.useDeprecatedSynchronousErrorHandling;
              if (this._error) {
                  if (!useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                      this.__tryOrUnsub(this._error, err);
                      this.unsubscribe();
                  }
                  else {
                      this.__tryOrSetError(_parentSubscriber, this._error, err);
                      this.unsubscribe();
                  }
              }
              else if (!_parentSubscriber.syncErrorThrowable) {
                  this.unsubscribe();
                  if (useDeprecatedSynchronousErrorHandling) {
                      throw err;
                  }
                  hostReportError(err);
              }
              else {
                  if (useDeprecatedSynchronousErrorHandling) {
                      _parentSubscriber.syncErrorValue = err;
                      _parentSubscriber.syncErrorThrown = true;
                  }
                  else {
                      hostReportError(err);
                  }
                  this.unsubscribe();
              }
          }
      };
      SafeSubscriber.prototype.complete = function () {
          var _this = this;
          if (!this.isStopped) {
              var _parentSubscriber = this._parentSubscriber;
              if (this._complete) {
                  var wrappedComplete = function () { return _this._complete.call(_this._context); };
                  if (!config.useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                      this.__tryOrUnsub(wrappedComplete);
                      this.unsubscribe();
                  }
                  else {
                      this.__tryOrSetError(_parentSubscriber, wrappedComplete);
                      this.unsubscribe();
                  }
              }
              else {
                  this.unsubscribe();
              }
          }
      };
      SafeSubscriber.prototype.__tryOrUnsub = function (fn, value) {
          try {
              fn.call(this._context, value);
          }
          catch (err) {
              this.unsubscribe();
              if (config.useDeprecatedSynchronousErrorHandling) {
                  throw err;
              }
              else {
                  hostReportError(err);
              }
          }
      };
      SafeSubscriber.prototype.__tryOrSetError = function (parent, fn, value) {
          if (!config.useDeprecatedSynchronousErrorHandling) {
              throw new Error('bad call');
          }
          try {
              fn.call(this._context, value);
          }
          catch (err) {
              if (config.useDeprecatedSynchronousErrorHandling) {
                  parent.syncErrorValue = err;
                  parent.syncErrorThrown = true;
                  return true;
              }
              else {
                  hostReportError(err);
                  return true;
              }
          }
          return false;
      };
      SafeSubscriber.prototype._unsubscribe = function () {
          var _parentSubscriber = this._parentSubscriber;
          this._context = null;
          this._parentSubscriber = null;
          _parentSubscriber.unsubscribe();
      };
      return SafeSubscriber;
  }(Subscriber));

  /** PURE_IMPORTS_START _Subscriber PURE_IMPORTS_END */
  function canReportError(observer) {
      while (observer) {
          var _a = observer, closed_1 = _a.closed, destination = _a.destination, isStopped = _a.isStopped;
          if (closed_1 || isStopped) {
              return false;
          }
          else if (destination && destination instanceof Subscriber) {
              observer = destination;
          }
          else {
              observer = null;
          }
      }
      return true;
  }

  /** PURE_IMPORTS_START _Subscriber,_symbol_rxSubscriber,_Observer PURE_IMPORTS_END */
  function toSubscriber(nextOrObserver, error, complete) {
      if (nextOrObserver) {
          if (nextOrObserver instanceof Subscriber) {
              return nextOrObserver;
          }
          if (nextOrObserver[rxSubscriber]) {
              return nextOrObserver[rxSubscriber]();
          }
      }
      if (!nextOrObserver && !error && !complete) {
          return new Subscriber(empty$1);
      }
      return new Subscriber(nextOrObserver, error, complete);
  }

  /** PURE_IMPORTS_START  PURE_IMPORTS_END */
  var observable = /*@__PURE__*/ (function () { return typeof Symbol === 'function' && Symbol.observable || '@@observable'; })();

  /** PURE_IMPORTS_START  PURE_IMPORTS_END */
  function identity(x) {
      return x;
  }

  /** PURE_IMPORTS_START _identity PURE_IMPORTS_END */
  function pipeFromArray(fns) {
      if (fns.length === 0) {
          return identity;
      }
      if (fns.length === 1) {
          return fns[0];
      }
      return function piped(input) {
          return fns.reduce(function (prev, fn) { return fn(prev); }, input);
      };
  }

  /** PURE_IMPORTS_START _util_canReportError,_util_toSubscriber,_symbol_observable,_util_pipe,_config PURE_IMPORTS_END */
  var Observable = /*@__PURE__*/ (function () {
      function Observable(subscribe) {
          this._isScalar = false;
          if (subscribe) {
              this._subscribe = subscribe;
          }
      }
      Observable.prototype.lift = function (operator) {
          var observable = new Observable();
          observable.source = this;
          observable.operator = operator;
          return observable;
      };
      Observable.prototype.subscribe = function (observerOrNext, error, complete) {
          var operator = this.operator;
          var sink = toSubscriber(observerOrNext, error, complete);
          if (operator) {
              sink.add(operator.call(sink, this.source));
          }
          else {
              sink.add(this.source || (config.useDeprecatedSynchronousErrorHandling && !sink.syncErrorThrowable) ?
                  this._subscribe(sink) :
                  this._trySubscribe(sink));
          }
          if (config.useDeprecatedSynchronousErrorHandling) {
              if (sink.syncErrorThrowable) {
                  sink.syncErrorThrowable = false;
                  if (sink.syncErrorThrown) {
                      throw sink.syncErrorValue;
                  }
              }
          }
          return sink;
      };
      Observable.prototype._trySubscribe = function (sink) {
          try {
              return this._subscribe(sink);
          }
          catch (err) {
              if (config.useDeprecatedSynchronousErrorHandling) {
                  sink.syncErrorThrown = true;
                  sink.syncErrorValue = err;
              }
              if (canReportError(sink)) {
                  sink.error(err);
              }
              else {
                  console.warn(err);
              }
          }
      };
      Observable.prototype.forEach = function (next, promiseCtor) {
          var _this = this;
          promiseCtor = getPromiseCtor(promiseCtor);
          return new promiseCtor(function (resolve, reject) {
              var subscription;
              subscription = _this.subscribe(function (value) {
                  try {
                      next(value);
                  }
                  catch (err) {
                      reject(err);
                      if (subscription) {
                          subscription.unsubscribe();
                      }
                  }
              }, reject, resolve);
          });
      };
      Observable.prototype._subscribe = function (subscriber) {
          var source = this.source;
          return source && source.subscribe(subscriber);
      };
      Observable.prototype[observable] = function () {
          return this;
      };
      Observable.prototype.pipe = function () {
          var operations = [];
          for (var _i = 0; _i < arguments.length; _i++) {
              operations[_i] = arguments[_i];
          }
          if (operations.length === 0) {
              return this;
          }
          return pipeFromArray(operations)(this);
      };
      Observable.prototype.toPromise = function (promiseCtor) {
          var _this = this;
          promiseCtor = getPromiseCtor(promiseCtor);
          return new promiseCtor(function (resolve, reject) {
              var value;
              _this.subscribe(function (x) { return value = x; }, function (err) { return reject(err); }, function () { return resolve(value); });
          });
      };
      Observable.create = function (subscribe) {
          return new Observable(subscribe);
      };
      return Observable;
  }());
  function getPromiseCtor(promiseCtor) {
      if (!promiseCtor) {
          promiseCtor = config.Promise || Promise;
      }
      if (!promiseCtor) {
          throw new Error('no Promise impl found');
      }
      return promiseCtor;
  }

  /** PURE_IMPORTS_START  PURE_IMPORTS_END */
  var subscribeToArray = function (array) {
      return function (subscriber) {
          for (var i = 0, len = array.length; i < len && !subscriber.closed; i++) {
              subscriber.next(array[i]);
          }
          subscriber.complete();
      };
  };

  /** PURE_IMPORTS_START _hostReportError PURE_IMPORTS_END */
  var subscribeToPromise = function (promise) {
      return function (subscriber) {
          promise.then(function (value) {
              if (!subscriber.closed) {
                  subscriber.next(value);
                  subscriber.complete();
              }
          }, function (err) { return subscriber.error(err); })
              .then(null, hostReportError);
          return subscriber;
      };
  };

  /** PURE_IMPORTS_START  PURE_IMPORTS_END */
  function getSymbolIterator() {
      if (typeof Symbol !== 'function' || !Symbol.iterator) {
          return '@@iterator';
      }
      return Symbol.iterator;
  }
  var iterator = /*@__PURE__*/ getSymbolIterator();

  /** PURE_IMPORTS_START _symbol_iterator PURE_IMPORTS_END */
  var subscribeToIterable = function (iterable) {
      return function (subscriber) {
          var iterator$1 = iterable[iterator]();
          do {
              var item = void 0;
              try {
                  item = iterator$1.next();
              }
              catch (err) {
                  subscriber.error(err);
                  return subscriber;
              }
              if (item.done) {
                  subscriber.complete();
                  break;
              }
              subscriber.next(item.value);
              if (subscriber.closed) {
                  break;
              }
          } while (true);
          if (typeof iterator$1.return === 'function') {
              subscriber.add(function () {
                  if (iterator$1.return) {
                      iterator$1.return();
                  }
              });
          }
          return subscriber;
      };
  };

  /** PURE_IMPORTS_START _symbol_observable PURE_IMPORTS_END */
  var subscribeToObservable = function (obj) {
      return function (subscriber) {
          var obs = obj[observable]();
          if (typeof obs.subscribe !== 'function') {
              throw new TypeError('Provided object does not correctly implement Symbol.observable');
          }
          else {
              return obs.subscribe(subscriber);
          }
      };
  };

  /** PURE_IMPORTS_START  PURE_IMPORTS_END */
  var isArrayLike = (function (x) { return x && typeof x.length === 'number' && typeof x !== 'function'; });

  /** PURE_IMPORTS_START  PURE_IMPORTS_END */
  function isPromise(value) {
      return !!value && typeof value.subscribe !== 'function' && typeof value.then === 'function';
  }

  /** PURE_IMPORTS_START _subscribeToArray,_subscribeToPromise,_subscribeToIterable,_subscribeToObservable,_isArrayLike,_isPromise,_isObject,_symbol_iterator,_symbol_observable PURE_IMPORTS_END */
  var subscribeTo = function (result) {
      if (!!result && typeof result[observable] === 'function') {
          return subscribeToObservable(result);
      }
      else if (isArrayLike(result)) {
          return subscribeToArray(result);
      }
      else if (isPromise(result)) {
          return subscribeToPromise(result);
      }
      else if (!!result && typeof result[iterator] === 'function') {
          return subscribeToIterable(result);
      }
      else {
          var value = isObject(result) ? 'an invalid object' : "'" + result + "'";
          var msg = "You provided " + value + " where a stream was expected."
              + ' You can provide an Observable, Promise, Array, or Iterable.';
          throw new TypeError(msg);
      }
  };

  /** PURE_IMPORTS_START tslib,_Subscriber,_Observable,_util_subscribeTo PURE_IMPORTS_END */
  var SimpleInnerSubscriber = /*@__PURE__*/ (function (_super) {
      __extends(SimpleInnerSubscriber, _super);
      function SimpleInnerSubscriber(parent) {
          var _this = _super.call(this) || this;
          _this.parent = parent;
          return _this;
      }
      SimpleInnerSubscriber.prototype._next = function (value) {
          this.parent.notifyNext(value);
      };
      SimpleInnerSubscriber.prototype._error = function (error) {
          this.parent.notifyError(error);
          this.unsubscribe();
      };
      SimpleInnerSubscriber.prototype._complete = function () {
          this.parent.notifyComplete();
          this.unsubscribe();
      };
      return SimpleInnerSubscriber;
  }(Subscriber));
  var SimpleOuterSubscriber = /*@__PURE__*/ (function (_super) {
      __extends(SimpleOuterSubscriber, _super);
      function SimpleOuterSubscriber() {
          return _super !== null && _super.apply(this, arguments) || this;
      }
      SimpleOuterSubscriber.prototype.notifyNext = function (innerValue) {
          this.destination.next(innerValue);
      };
      SimpleOuterSubscriber.prototype.notifyError = function (err) {
          this.destination.error(err);
      };
      SimpleOuterSubscriber.prototype.notifyComplete = function () {
          this.destination.complete();
      };
      return SimpleOuterSubscriber;
  }(Subscriber));
  function innerSubscribe(result, innerSubscriber) {
      if (innerSubscriber.closed) {
          return undefined;
      }
      if (result instanceof Observable) {
          return result.subscribe(innerSubscriber);
      }
      var subscription;
      try {
          subscription = subscribeTo(result)(innerSubscriber);
      }
      catch (error) {
          innerSubscriber.error(error);
      }
      return subscription;
  }

  /** PURE_IMPORTS_START tslib,_Subscription PURE_IMPORTS_END */
  var Action = /*@__PURE__*/ (function (_super) {
      __extends(Action, _super);
      function Action(scheduler, work) {
          return _super.call(this) || this;
      }
      Action.prototype.schedule = function (state, delay) {
          return this;
      };
      return Action;
  }(Subscription));

  /** PURE_IMPORTS_START tslib,_Action PURE_IMPORTS_END */
  var AsyncAction = /*@__PURE__*/ (function (_super) {
      __extends(AsyncAction, _super);
      function AsyncAction(scheduler, work) {
          var _this = _super.call(this, scheduler, work) || this;
          _this.scheduler = scheduler;
          _this.work = work;
          _this.pending = false;
          return _this;
      }
      AsyncAction.prototype.schedule = function (state, delay) {
          if (delay === void 0) {
              delay = 0;
          }
          if (this.closed) {
              return this;
          }
          this.state = state;
          var id = this.id;
          var scheduler = this.scheduler;
          if (id != null) {
              this.id = this.recycleAsyncId(scheduler, id, delay);
          }
          this.pending = true;
          this.delay = delay;
          this.id = this.id || this.requestAsyncId(scheduler, this.id, delay);
          return this;
      };
      AsyncAction.prototype.requestAsyncId = function (scheduler, id, delay) {
          if (delay === void 0) {
              delay = 0;
          }
          return setInterval(scheduler.flush.bind(scheduler, this), delay);
      };
      AsyncAction.prototype.recycleAsyncId = function (scheduler, id, delay) {
          if (delay === void 0) {
              delay = 0;
          }
          if (delay !== null && this.delay === delay && this.pending === false) {
              return id;
          }
          clearInterval(id);
          return undefined;
      };
      AsyncAction.prototype.execute = function (state, delay) {
          if (this.closed) {
              return new Error('executing a cancelled action');
          }
          this.pending = false;
          var error = this._execute(state, delay);
          if (error) {
              return error;
          }
          else if (this.pending === false && this.id != null) {
              this.id = this.recycleAsyncId(this.scheduler, this.id, null);
          }
      };
      AsyncAction.prototype._execute = function (state, delay) {
          var errored = false;
          var errorValue = undefined;
          try {
              this.work(state);
          }
          catch (e) {
              errored = true;
              errorValue = !!e && e || new Error(e);
          }
          if (errored) {
              this.unsubscribe();
              return errorValue;
          }
      };
      AsyncAction.prototype._unsubscribe = function () {
          var id = this.id;
          var scheduler = this.scheduler;
          var actions = scheduler.actions;
          var index = actions.indexOf(this);
          this.work = null;
          this.state = null;
          this.pending = false;
          this.scheduler = null;
          if (index !== -1) {
              actions.splice(index, 1);
          }
          if (id != null) {
              this.id = this.recycleAsyncId(scheduler, id, null);
          }
          this.delay = null;
      };
      return AsyncAction;
  }(Action));

  var Scheduler = /*@__PURE__*/ (function () {
      function Scheduler(SchedulerAction, now) {
          if (now === void 0) {
              now = Scheduler.now;
          }
          this.SchedulerAction = SchedulerAction;
          this.now = now;
      }
      Scheduler.prototype.schedule = function (work, delay, state) {
          if (delay === void 0) {
              delay = 0;
          }
          return new this.SchedulerAction(this, work).schedule(state, delay);
      };
      Scheduler.now = function () { return Date.now(); };
      return Scheduler;
  }());

  /** PURE_IMPORTS_START tslib,_Scheduler PURE_IMPORTS_END */
  var AsyncScheduler = /*@__PURE__*/ (function (_super) {
      __extends(AsyncScheduler, _super);
      function AsyncScheduler(SchedulerAction, now) {
          if (now === void 0) {
              now = Scheduler.now;
          }
          var _this = _super.call(this, SchedulerAction, function () {
              if (AsyncScheduler.delegate && AsyncScheduler.delegate !== _this) {
                  return AsyncScheduler.delegate.now();
              }
              else {
                  return now();
              }
          }) || this;
          _this.actions = [];
          _this.active = false;
          _this.scheduled = undefined;
          return _this;
      }
      AsyncScheduler.prototype.schedule = function (work, delay, state) {
          if (delay === void 0) {
              delay = 0;
          }
          if (AsyncScheduler.delegate && AsyncScheduler.delegate !== this) {
              return AsyncScheduler.delegate.schedule(work, delay, state);
          }
          else {
              return _super.prototype.schedule.call(this, work, delay, state);
          }
      };
      AsyncScheduler.prototype.flush = function (action) {
          var actions = this.actions;
          if (this.active) {
              actions.push(action);
              return;
          }
          var error;
          this.active = true;
          do {
              if (error = action.execute(action.state, action.delay)) {
                  break;
              }
          } while (action = actions.shift());
          this.active = false;
          if (error) {
              while (action = actions.shift()) {
                  action.unsubscribe();
              }
              throw error;
          }
      };
      return AsyncScheduler;
  }(Scheduler));

  /** PURE_IMPORTS_START _AsyncAction,_AsyncScheduler PURE_IMPORTS_END */
  var asyncScheduler = /*@__PURE__*/ new AsyncScheduler(AsyncAction);
  var async = asyncScheduler;

  /** PURE_IMPORTS_START  PURE_IMPORTS_END */
  function isScheduler(value) {
      return value && typeof value.schedule === 'function';
  }

  /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
  var InnerSubscriber = /*@__PURE__*/ (function (_super) {
      __extends(InnerSubscriber, _super);
      function InnerSubscriber(parent, outerValue, outerIndex) {
          var _this = _super.call(this) || this;
          _this.parent = parent;
          _this.outerValue = outerValue;
          _this.outerIndex = outerIndex;
          _this.index = 0;
          return _this;
      }
      InnerSubscriber.prototype._next = function (value) {
          this.parent.notifyNext(this.outerValue, value, this.outerIndex, this.index++, this);
      };
      InnerSubscriber.prototype._error = function (error) {
          this.parent.notifyError(error, this);
          this.unsubscribe();
      };
      InnerSubscriber.prototype._complete = function () {
          this.parent.notifyComplete(this);
          this.unsubscribe();
      };
      return InnerSubscriber;
  }(Subscriber));

  /** PURE_IMPORTS_START _InnerSubscriber,_subscribeTo,_Observable PURE_IMPORTS_END */
  function subscribeToResult(outerSubscriber, result, outerValue, outerIndex, innerSubscriber) {
      if (innerSubscriber === void 0) {
          innerSubscriber = new InnerSubscriber(outerSubscriber, outerValue, outerIndex);
      }
      if (innerSubscriber.closed) {
          return undefined;
      }
      if (result instanceof Observable) {
          return result.subscribe(innerSubscriber);
      }
      return subscribeTo(result)(innerSubscriber);
  }

  /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
  var OuterSubscriber = /*@__PURE__*/ (function (_super) {
      __extends(OuterSubscriber, _super);
      function OuterSubscriber() {
          return _super !== null && _super.apply(this, arguments) || this;
      }
      OuterSubscriber.prototype.notifyNext = function (outerValue, innerValue, outerIndex, innerIndex, innerSub) {
          this.destination.next(innerValue);
      };
      OuterSubscriber.prototype.notifyError = function (error, innerSub) {
          this.destination.error(error);
      };
      OuterSubscriber.prototype.notifyComplete = function (innerSub) {
          this.destination.complete();
      };
      return OuterSubscriber;
  }(Subscriber));

  /** PURE_IMPORTS_START tslib,_innerSubscribe PURE_IMPORTS_END */
  function catchError(selector) {
      return function catchErrorOperatorFunction(source) {
          var operator = new CatchOperator(selector);
          var caught = source.lift(operator);
          return (operator.caught = caught);
      };
  }
  var CatchOperator = /*@__PURE__*/ (function () {
      function CatchOperator(selector) {
          this.selector = selector;
      }
      CatchOperator.prototype.call = function (subscriber, source) {
          return source.subscribe(new CatchSubscriber(subscriber, this.selector, this.caught));
      };
      return CatchOperator;
  }());
  var CatchSubscriber = /*@__PURE__*/ (function (_super) {
      __extends(CatchSubscriber, _super);
      function CatchSubscriber(destination, selector, caught) {
          var _this = _super.call(this, destination) || this;
          _this.selector = selector;
          _this.caught = caught;
          return _this;
      }
      CatchSubscriber.prototype.error = function (err) {
          if (!this.isStopped) {
              var result = void 0;
              try {
                  result = this.selector(err, this.caught);
              }
              catch (err2) {
                  _super.prototype.error.call(this, err2);
                  return;
              }
              this._unsubscribeAndRecycle();
              var innerSubscriber = new SimpleInnerSubscriber(this);
              this.add(innerSubscriber);
              var innerSubscription = innerSubscribe(result, innerSubscriber);
              if (innerSubscription !== innerSubscriber) {
                  this.add(innerSubscription);
              }
          }
      };
      return CatchSubscriber;
  }(SimpleOuterSubscriber));

  /** PURE_IMPORTS_START _Observable,_Subscription PURE_IMPORTS_END */
  function scheduleArray(input, scheduler) {
      return new Observable(function (subscriber) {
          var sub = new Subscription();
          var i = 0;
          sub.add(scheduler.schedule(function () {
              if (i === input.length) {
                  subscriber.complete();
                  return;
              }
              subscriber.next(input[i++]);
              if (!subscriber.closed) {
                  sub.add(this.schedule());
              }
          }));
          return sub;
      });
  }

  /** PURE_IMPORTS_START _Observable,_util_subscribeToArray,_scheduled_scheduleArray PURE_IMPORTS_END */
  function fromArray(input, scheduler) {
      if (!scheduler) {
          return new Observable(subscribeToArray(input));
      }
      else {
          return scheduleArray(input, scheduler);
      }
  }

  /** PURE_IMPORTS_START _Observable,_Subscription,_symbol_observable PURE_IMPORTS_END */
  function scheduleObservable(input, scheduler) {
      return new Observable(function (subscriber) {
          var sub = new Subscription();
          sub.add(scheduler.schedule(function () {
              var observable$1 = input[observable]();
              sub.add(observable$1.subscribe({
                  next: function (value) { sub.add(scheduler.schedule(function () { return subscriber.next(value); })); },
                  error: function (err) { sub.add(scheduler.schedule(function () { return subscriber.error(err); })); },
                  complete: function () { sub.add(scheduler.schedule(function () { return subscriber.complete(); })); },
              }));
          }));
          return sub;
      });
  }

  /** PURE_IMPORTS_START _Observable,_Subscription PURE_IMPORTS_END */
  function schedulePromise(input, scheduler) {
      return new Observable(function (subscriber) {
          var sub = new Subscription();
          sub.add(scheduler.schedule(function () {
              return input.then(function (value) {
                  sub.add(scheduler.schedule(function () {
                      subscriber.next(value);
                      sub.add(scheduler.schedule(function () { return subscriber.complete(); }));
                  }));
              }, function (err) {
                  sub.add(scheduler.schedule(function () { return subscriber.error(err); }));
              });
          }));
          return sub;
      });
  }

  /** PURE_IMPORTS_START _Observable,_Subscription,_symbol_iterator PURE_IMPORTS_END */
  function scheduleIterable(input, scheduler) {
      if (!input) {
          throw new Error('Iterable cannot be null');
      }
      return new Observable(function (subscriber) {
          var sub = new Subscription();
          var iterator$1;
          sub.add(function () {
              if (iterator$1 && typeof iterator$1.return === 'function') {
                  iterator$1.return();
              }
          });
          sub.add(scheduler.schedule(function () {
              iterator$1 = input[iterator]();
              sub.add(scheduler.schedule(function () {
                  if (subscriber.closed) {
                      return;
                  }
                  var value;
                  var done;
                  try {
                      var result = iterator$1.next();
                      value = result.value;
                      done = result.done;
                  }
                  catch (err) {
                      subscriber.error(err);
                      return;
                  }
                  if (done) {
                      subscriber.complete();
                  }
                  else {
                      subscriber.next(value);
                      this.schedule();
                  }
              }));
          }));
          return sub;
      });
  }

  /** PURE_IMPORTS_START _symbol_observable PURE_IMPORTS_END */
  function isInteropObservable(input) {
      return input && typeof input[observable] === 'function';
  }

  /** PURE_IMPORTS_START _symbol_iterator PURE_IMPORTS_END */
  function isIterable(input) {
      return input && typeof input[iterator] === 'function';
  }

  /** PURE_IMPORTS_START _scheduleObservable,_schedulePromise,_scheduleArray,_scheduleIterable,_util_isInteropObservable,_util_isPromise,_util_isArrayLike,_util_isIterable PURE_IMPORTS_END */
  function scheduled(input, scheduler) {
      if (input != null) {
          if (isInteropObservable(input)) {
              return scheduleObservable(input, scheduler);
          }
          else if (isPromise(input)) {
              return schedulePromise(input, scheduler);
          }
          else if (isArrayLike(input)) {
              return scheduleArray(input, scheduler);
          }
          else if (isIterable(input) || typeof input === 'string') {
              return scheduleIterable(input, scheduler);
          }
      }
      throw new TypeError((input !== null && typeof input || input) + ' is not observable');
  }

  /** PURE_IMPORTS_START _Observable,_util_subscribeTo,_scheduled_scheduled PURE_IMPORTS_END */
  function from(input, scheduler) {
      if (!scheduler) {
          if (input instanceof Observable) {
              return input;
          }
          return new Observable(subscribeTo(input));
      }
      else {
          return scheduled(input, scheduler);
      }
  }

  /** PURE_IMPORTS_START _util_isScheduler,_fromArray,_scheduled_scheduleArray PURE_IMPORTS_END */
  function of() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
          args[_i] = arguments[_i];
      }
      var scheduler = args[args.length - 1];
      if (isScheduler(scheduler)) {
          args.pop();
          return scheduleArray(args, scheduler);
      }
      else {
          return fromArray(args);
      }
  }

  /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
  function map(project, thisArg) {
      return function mapOperation(source) {
          if (typeof project !== 'function') {
              throw new TypeError('argument is not a function. Are you looking for `mapTo()`?');
          }
          return source.lift(new MapOperator(project, thisArg));
      };
  }
  var MapOperator = /*@__PURE__*/ (function () {
      function MapOperator(project, thisArg) {
          this.project = project;
          this.thisArg = thisArg;
      }
      MapOperator.prototype.call = function (subscriber, source) {
          return source.subscribe(new MapSubscriber(subscriber, this.project, this.thisArg));
      };
      return MapOperator;
  }());
  var MapSubscriber = /*@__PURE__*/ (function (_super) {
      __extends(MapSubscriber, _super);
      function MapSubscriber(destination, project, thisArg) {
          var _this = _super.call(this, destination) || this;
          _this.project = project;
          _this.count = 0;
          _this.thisArg = thisArg || _this;
          return _this;
      }
      MapSubscriber.prototype._next = function (value) {
          var result;
          try {
              result = this.project.call(this.thisArg, value, this.count++);
          }
          catch (err) {
              this.destination.error(err);
              return;
          }
          this.destination.next(result);
      };
      return MapSubscriber;
  }(Subscriber));

  /** PURE_IMPORTS_START tslib,_map,_observable_from,_innerSubscribe PURE_IMPORTS_END */
  function mergeMap(project, resultSelector, concurrent) {
      if (concurrent === void 0) {
          concurrent = Number.POSITIVE_INFINITY;
      }
      if (typeof resultSelector === 'function') {
          return function (source) { return source.pipe(mergeMap(function (a, i) { return from(project(a, i)).pipe(map(function (b, ii) { return resultSelector(a, b, i, ii); })); }, concurrent)); };
      }
      else if (typeof resultSelector === 'number') {
          concurrent = resultSelector;
      }
      return function (source) { return source.lift(new MergeMapOperator(project, concurrent)); };
  }
  var MergeMapOperator = /*@__PURE__*/ (function () {
      function MergeMapOperator(project, concurrent) {
          if (concurrent === void 0) {
              concurrent = Number.POSITIVE_INFINITY;
          }
          this.project = project;
          this.concurrent = concurrent;
      }
      MergeMapOperator.prototype.call = function (observer, source) {
          return source.subscribe(new MergeMapSubscriber(observer, this.project, this.concurrent));
      };
      return MergeMapOperator;
  }());
  var MergeMapSubscriber = /*@__PURE__*/ (function (_super) {
      __extends(MergeMapSubscriber, _super);
      function MergeMapSubscriber(destination, project, concurrent) {
          if (concurrent === void 0) {
              concurrent = Number.POSITIVE_INFINITY;
          }
          var _this = _super.call(this, destination) || this;
          _this.project = project;
          _this.concurrent = concurrent;
          _this.hasCompleted = false;
          _this.buffer = [];
          _this.active = 0;
          _this.index = 0;
          return _this;
      }
      MergeMapSubscriber.prototype._next = function (value) {
          if (this.active < this.concurrent) {
              this._tryNext(value);
          }
          else {
              this.buffer.push(value);
          }
      };
      MergeMapSubscriber.prototype._tryNext = function (value) {
          var result;
          var index = this.index++;
          try {
              result = this.project(value, index);
          }
          catch (err) {
              this.destination.error(err);
              return;
          }
          this.active++;
          this._innerSub(result);
      };
      MergeMapSubscriber.prototype._innerSub = function (ish) {
          var innerSubscriber = new SimpleInnerSubscriber(this);
          var destination = this.destination;
          destination.add(innerSubscriber);
          var innerSubscription = innerSubscribe(ish, innerSubscriber);
          if (innerSubscription !== innerSubscriber) {
              destination.add(innerSubscription);
          }
      };
      MergeMapSubscriber.prototype._complete = function () {
          this.hasCompleted = true;
          if (this.active === 0 && this.buffer.length === 0) {
              this.destination.complete();
          }
          this.unsubscribe();
      };
      MergeMapSubscriber.prototype.notifyNext = function (innerValue) {
          this.destination.next(innerValue);
      };
      MergeMapSubscriber.prototype.notifyComplete = function () {
          var buffer = this.buffer;
          this.active--;
          if (buffer.length > 0) {
              this._next(buffer.shift());
          }
          else if (this.active === 0 && this.hasCompleted) {
              this.destination.complete();
          }
      };
      return MergeMapSubscriber;
  }(SimpleOuterSubscriber));

  /** PURE_IMPORTS_START _mergeMap PURE_IMPORTS_END */
  function concatMap(project, resultSelector) {
      return mergeMap(project, resultSelector, 1);
  }

  /** PURE_IMPORTS_START  PURE_IMPORTS_END */
  function isDate(value) {
      return value instanceof Date && !isNaN(+value);
  }

  /** PURE_IMPORTS_START _Observable PURE_IMPORTS_END */
  var EMPTY = /*@__PURE__*/ new Observable(function (subscriber) { return subscriber.complete(); });
  function empty(scheduler) {
      return scheduler ? emptyScheduled(scheduler) : EMPTY;
  }
  function emptyScheduled(scheduler) {
      return new Observable(function (subscriber) { return scheduler.schedule(function () { return subscriber.complete(); }); });
  }

  /** PURE_IMPORTS_START _Observable PURE_IMPORTS_END */
  function throwError(error, scheduler) {
      if (!scheduler) {
          return new Observable(function (subscriber) { return subscriber.error(error); });
      }
      else {
          return new Observable(function (subscriber) { return scheduler.schedule(dispatch, 0, { error: error, subscriber: subscriber }); });
      }
  }
  function dispatch(_a) {
      var error = _a.error, subscriber = _a.subscriber;
      subscriber.error(error);
  }

  /** PURE_IMPORTS_START _observable_empty,_observable_of,_observable_throwError PURE_IMPORTS_END */
  var Notification = /*@__PURE__*/ (function () {
      function Notification(kind, value, error) {
          this.kind = kind;
          this.value = value;
          this.error = error;
          this.hasValue = kind === 'N';
      }
      Notification.prototype.observe = function (observer) {
          switch (this.kind) {
              case 'N':
                  return observer.next && observer.next(this.value);
              case 'E':
                  return observer.error && observer.error(this.error);
              case 'C':
                  return observer.complete && observer.complete();
          }
      };
      Notification.prototype.do = function (next, error, complete) {
          var kind = this.kind;
          switch (kind) {
              case 'N':
                  return next && next(this.value);
              case 'E':
                  return error && error(this.error);
              case 'C':
                  return complete && complete();
          }
      };
      Notification.prototype.accept = function (nextOrObserver, error, complete) {
          if (nextOrObserver && typeof nextOrObserver.next === 'function') {
              return this.observe(nextOrObserver);
          }
          else {
              return this.do(nextOrObserver, error, complete);
          }
      };
      Notification.prototype.toObservable = function () {
          var kind = this.kind;
          switch (kind) {
              case 'N':
                  return of(this.value);
              case 'E':
                  return throwError(this.error);
              case 'C':
                  return empty();
          }
          throw new Error('unexpected notification kind value');
      };
      Notification.createNext = function (value) {
          if (typeof value !== 'undefined') {
              return new Notification('N', value);
          }
          return Notification.undefinedValueNotification;
      };
      Notification.createError = function (err) {
          return new Notification('E', undefined, err);
      };
      Notification.createComplete = function () {
          return Notification.completeNotification;
      };
      Notification.completeNotification = new Notification('C');
      Notification.undefinedValueNotification = new Notification('N', undefined);
      return Notification;
  }());

  /** PURE_IMPORTS_START tslib,_scheduler_async,_util_isDate,_Subscriber,_Notification PURE_IMPORTS_END */
  function delay(delay, scheduler) {
      if (scheduler === void 0) {
          scheduler = async;
      }
      var absoluteDelay = isDate(delay);
      var delayFor = absoluteDelay ? (+delay - scheduler.now()) : Math.abs(delay);
      return function (source) { return source.lift(new DelayOperator(delayFor, scheduler)); };
  }
  var DelayOperator = /*@__PURE__*/ (function () {
      function DelayOperator(delay, scheduler) {
          this.delay = delay;
          this.scheduler = scheduler;
      }
      DelayOperator.prototype.call = function (subscriber, source) {
          return source.subscribe(new DelaySubscriber(subscriber, this.delay, this.scheduler));
      };
      return DelayOperator;
  }());
  var DelaySubscriber = /*@__PURE__*/ (function (_super) {
      __extends(DelaySubscriber, _super);
      function DelaySubscriber(destination, delay, scheduler) {
          var _this = _super.call(this, destination) || this;
          _this.delay = delay;
          _this.scheduler = scheduler;
          _this.queue = [];
          _this.active = false;
          _this.errored = false;
          return _this;
      }
      DelaySubscriber.dispatch = function (state) {
          var source = state.source;
          var queue = source.queue;
          var scheduler = state.scheduler;
          var destination = state.destination;
          while (queue.length > 0 && (queue[0].time - scheduler.now()) <= 0) {
              queue.shift().notification.observe(destination);
          }
          if (queue.length > 0) {
              var delay_1 = Math.max(0, queue[0].time - scheduler.now());
              this.schedule(state, delay_1);
          }
          else {
              this.unsubscribe();
              source.active = false;
          }
      };
      DelaySubscriber.prototype._schedule = function (scheduler) {
          this.active = true;
          var destination = this.destination;
          destination.add(scheduler.schedule(DelaySubscriber.dispatch, this.delay, {
              source: this, destination: this.destination, scheduler: scheduler
          }));
      };
      DelaySubscriber.prototype.scheduleNotification = function (notification) {
          if (this.errored === true) {
              return;
          }
          var scheduler = this.scheduler;
          var message = new DelayMessage(scheduler.now() + this.delay, notification);
          this.queue.push(message);
          if (this.active === false) {
              this._schedule(scheduler);
          }
      };
      DelaySubscriber.prototype._next = function (value) {
          this.scheduleNotification(Notification.createNext(value));
      };
      DelaySubscriber.prototype._error = function (err) {
          this.errored = true;
          this.queue = [];
          this.destination.error(err);
          this.unsubscribe();
      };
      DelaySubscriber.prototype._complete = function () {
          this.scheduleNotification(Notification.createComplete());
          this.unsubscribe();
      };
      return DelaySubscriber;
  }(Subscriber));
  var DelayMessage = /*@__PURE__*/ (function () {
      function DelayMessage(time, notification) {
          this.time = time;
          this.notification = notification;
      }
      return DelayMessage;
  }());

  /** PURE_IMPORTS_START tslib,_Subscriber,_Observable,_OuterSubscriber,_util_subscribeToResult PURE_IMPORTS_END */
  function delayWhen(delayDurationSelector, subscriptionDelay) {
      if (subscriptionDelay) {
          return function (source) {
              return new SubscriptionDelayObservable(source, subscriptionDelay)
                  .lift(new DelayWhenOperator(delayDurationSelector));
          };
      }
      return function (source) { return source.lift(new DelayWhenOperator(delayDurationSelector)); };
  }
  var DelayWhenOperator = /*@__PURE__*/ (function () {
      function DelayWhenOperator(delayDurationSelector) {
          this.delayDurationSelector = delayDurationSelector;
      }
      DelayWhenOperator.prototype.call = function (subscriber, source) {
          return source.subscribe(new DelayWhenSubscriber(subscriber, this.delayDurationSelector));
      };
      return DelayWhenOperator;
  }());
  var DelayWhenSubscriber = /*@__PURE__*/ (function (_super) {
      __extends(DelayWhenSubscriber, _super);
      function DelayWhenSubscriber(destination, delayDurationSelector) {
          var _this = _super.call(this, destination) || this;
          _this.delayDurationSelector = delayDurationSelector;
          _this.completed = false;
          _this.delayNotifierSubscriptions = [];
          _this.index = 0;
          return _this;
      }
      DelayWhenSubscriber.prototype.notifyNext = function (outerValue, _innerValue, _outerIndex, _innerIndex, innerSub) {
          this.destination.next(outerValue);
          this.removeSubscription(innerSub);
          this.tryComplete();
      };
      DelayWhenSubscriber.prototype.notifyError = function (error, innerSub) {
          this._error(error);
      };
      DelayWhenSubscriber.prototype.notifyComplete = function (innerSub) {
          var value = this.removeSubscription(innerSub);
          if (value) {
              this.destination.next(value);
          }
          this.tryComplete();
      };
      DelayWhenSubscriber.prototype._next = function (value) {
          var index = this.index++;
          try {
              var delayNotifier = this.delayDurationSelector(value, index);
              if (delayNotifier) {
                  this.tryDelay(delayNotifier, value);
              }
          }
          catch (err) {
              this.destination.error(err);
          }
      };
      DelayWhenSubscriber.prototype._complete = function () {
          this.completed = true;
          this.tryComplete();
          this.unsubscribe();
      };
      DelayWhenSubscriber.prototype.removeSubscription = function (subscription) {
          subscription.unsubscribe();
          var subscriptionIdx = this.delayNotifierSubscriptions.indexOf(subscription);
          if (subscriptionIdx !== -1) {
              this.delayNotifierSubscriptions.splice(subscriptionIdx, 1);
          }
          return subscription.outerValue;
      };
      DelayWhenSubscriber.prototype.tryDelay = function (delayNotifier, value) {
          var notifierSubscription = subscribeToResult(this, delayNotifier, value);
          if (notifierSubscription && !notifierSubscription.closed) {
              var destination = this.destination;
              destination.add(notifierSubscription);
              this.delayNotifierSubscriptions.push(notifierSubscription);
          }
      };
      DelayWhenSubscriber.prototype.tryComplete = function () {
          if (this.completed && this.delayNotifierSubscriptions.length === 0) {
              this.destination.complete();
          }
      };
      return DelayWhenSubscriber;
  }(OuterSubscriber));
  var SubscriptionDelayObservable = /*@__PURE__*/ (function (_super) {
      __extends(SubscriptionDelayObservable, _super);
      function SubscriptionDelayObservable(source, subscriptionDelay) {
          var _this = _super.call(this) || this;
          _this.source = source;
          _this.subscriptionDelay = subscriptionDelay;
          return _this;
      }
      SubscriptionDelayObservable.prototype._subscribe = function (subscriber) {
          this.subscriptionDelay.subscribe(new SubscriptionDelaySubscriber(subscriber, this.source));
      };
      return SubscriptionDelayObservable;
  }(Observable));
  var SubscriptionDelaySubscriber = /*@__PURE__*/ (function (_super) {
      __extends(SubscriptionDelaySubscriber, _super);
      function SubscriptionDelaySubscriber(parent, source) {
          var _this = _super.call(this) || this;
          _this.parent = parent;
          _this.source = source;
          _this.sourceSubscribed = false;
          return _this;
      }
      SubscriptionDelaySubscriber.prototype._next = function (unused) {
          this.subscribeToSource();
      };
      SubscriptionDelaySubscriber.prototype._error = function (err) {
          this.unsubscribe();
          this.parent.error(err);
      };
      SubscriptionDelaySubscriber.prototype._complete = function () {
          this.unsubscribe();
          this.subscribeToSource();
      };
      SubscriptionDelaySubscriber.prototype.subscribeToSource = function () {
          if (!this.sourceSubscribed) {
              this.sourceSubscribed = true;
              this.unsubscribe();
              this.source.subscribe(this.parent);
          }
      };
      return SubscriptionDelaySubscriber;
  }(Subscriber));

  /** PURE_IMPORTS_START  PURE_IMPORTS_END */
  var ArgumentOutOfRangeErrorImpl = /*@__PURE__*/ (function () {
      function ArgumentOutOfRangeErrorImpl() {
          Error.call(this);
          this.message = 'argument out of range';
          this.name = 'ArgumentOutOfRangeError';
          return this;
      }
      ArgumentOutOfRangeErrorImpl.prototype = /*@__PURE__*/ Object.create(Error.prototype);
      return ArgumentOutOfRangeErrorImpl;
  })();
  var ArgumentOutOfRangeError = ArgumentOutOfRangeErrorImpl;

  /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
  function filter(predicate, thisArg) {
      return function filterOperatorFunction(source) {
          return source.lift(new FilterOperator(predicate, thisArg));
      };
  }
  var FilterOperator = /*@__PURE__*/ (function () {
      function FilterOperator(predicate, thisArg) {
          this.predicate = predicate;
          this.thisArg = thisArg;
      }
      FilterOperator.prototype.call = function (subscriber, source) {
          return source.subscribe(new FilterSubscriber(subscriber, this.predicate, this.thisArg));
      };
      return FilterOperator;
  }());
  var FilterSubscriber = /*@__PURE__*/ (function (_super) {
      __extends(FilterSubscriber, _super);
      function FilterSubscriber(destination, predicate, thisArg) {
          var _this = _super.call(this, destination) || this;
          _this.predicate = predicate;
          _this.thisArg = thisArg;
          _this.count = 0;
          return _this;
      }
      FilterSubscriber.prototype._next = function (value) {
          var result;
          try {
              result = this.predicate.call(this.thisArg, value, this.count++);
          }
          catch (err) {
              this.destination.error(err);
              return;
          }
          if (result) {
              this.destination.next(value);
          }
      };
      return FilterSubscriber;
  }(Subscriber));

  /** PURE_IMPORTS_START tslib,_Subscriber,_util_ArgumentOutOfRangeError,_observable_empty PURE_IMPORTS_END */
  function take(count) {
      return function (source) {
          if (count === 0) {
              return empty();
          }
          else {
              return source.lift(new TakeOperator(count));
          }
      };
  }
  var TakeOperator = /*@__PURE__*/ (function () {
      function TakeOperator(total) {
          this.total = total;
          if (this.total < 0) {
              throw new ArgumentOutOfRangeError;
          }
      }
      TakeOperator.prototype.call = function (subscriber, source) {
          return source.subscribe(new TakeSubscriber(subscriber, this.total));
      };
      return TakeOperator;
  }());
  var TakeSubscriber = /*@__PURE__*/ (function (_super) {
      __extends(TakeSubscriber, _super);
      function TakeSubscriber(destination, total) {
          var _this = _super.call(this, destination) || this;
          _this.total = total;
          _this.count = 0;
          return _this;
      }
      TakeSubscriber.prototype._next = function (value) {
          var total = this.total;
          var count = ++this.count;
          if (count <= total) {
              this.destination.next(value);
              if (count === total) {
                  this.destination.complete();
                  this.unsubscribe();
              }
          }
      };
      return TakeSubscriber;
  }(Subscriber));

  /** PURE_IMPORTS_START tslib,_map,_observable_from,_innerSubscribe PURE_IMPORTS_END */
  function exhaustMap(project, resultSelector) {
      if (resultSelector) {
          return function (source) { return source.pipe(exhaustMap(function (a, i) { return from(project(a, i)).pipe(map(function (b, ii) { return resultSelector(a, b, i, ii); })); })); };
      }
      return function (source) {
          return source.lift(new ExhaustMapOperator(project));
      };
  }
  var ExhaustMapOperator = /*@__PURE__*/ (function () {
      function ExhaustMapOperator(project) {
          this.project = project;
      }
      ExhaustMapOperator.prototype.call = function (subscriber, source) {
          return source.subscribe(new ExhaustMapSubscriber(subscriber, this.project));
      };
      return ExhaustMapOperator;
  }());
  var ExhaustMapSubscriber = /*@__PURE__*/ (function (_super) {
      __extends(ExhaustMapSubscriber, _super);
      function ExhaustMapSubscriber(destination, project) {
          var _this = _super.call(this, destination) || this;
          _this.project = project;
          _this.hasSubscription = false;
          _this.hasCompleted = false;
          _this.index = 0;
          return _this;
      }
      ExhaustMapSubscriber.prototype._next = function (value) {
          if (!this.hasSubscription) {
              this.tryNext(value);
          }
      };
      ExhaustMapSubscriber.prototype.tryNext = function (value) {
          var result;
          var index = this.index++;
          try {
              result = this.project(value, index);
          }
          catch (err) {
              this.destination.error(err);
              return;
          }
          this.hasSubscription = true;
          this._innerSub(result);
      };
      ExhaustMapSubscriber.prototype._innerSub = function (result) {
          var innerSubscriber = new SimpleInnerSubscriber(this);
          var destination = this.destination;
          destination.add(innerSubscriber);
          var innerSubscription = innerSubscribe(result, innerSubscriber);
          if (innerSubscription !== innerSubscriber) {
              destination.add(innerSubscription);
          }
      };
      ExhaustMapSubscriber.prototype._complete = function () {
          this.hasCompleted = true;
          if (!this.hasSubscription) {
              this.destination.complete();
          }
          this.unsubscribe();
      };
      ExhaustMapSubscriber.prototype.notifyNext = function (innerValue) {
          this.destination.next(innerValue);
      };
      ExhaustMapSubscriber.prototype.notifyError = function (err) {
          this.destination.error(err);
      };
      ExhaustMapSubscriber.prototype.notifyComplete = function () {
          this.hasSubscription = false;
          if (this.hasCompleted) {
              this.destination.complete();
          }
      };
      return ExhaustMapSubscriber;
  }(SimpleOuterSubscriber));

  /** PURE_IMPORTS_START  PURE_IMPORTS_END */
  var ObjectUnsubscribedErrorImpl = /*@__PURE__*/ (function () {
      function ObjectUnsubscribedErrorImpl() {
          Error.call(this);
          this.message = 'object unsubscribed';
          this.name = 'ObjectUnsubscribedError';
          return this;
      }
      ObjectUnsubscribedErrorImpl.prototype = /*@__PURE__*/ Object.create(Error.prototype);
      return ObjectUnsubscribedErrorImpl;
  })();
  var ObjectUnsubscribedError = ObjectUnsubscribedErrorImpl;

  /** PURE_IMPORTS_START tslib,_Subscription PURE_IMPORTS_END */
  var SubjectSubscription = /*@__PURE__*/ (function (_super) {
      __extends(SubjectSubscription, _super);
      function SubjectSubscription(subject, subscriber) {
          var _this = _super.call(this) || this;
          _this.subject = subject;
          _this.subscriber = subscriber;
          _this.closed = false;
          return _this;
      }
      SubjectSubscription.prototype.unsubscribe = function () {
          if (this.closed) {
              return;
          }
          this.closed = true;
          var subject = this.subject;
          var observers = subject.observers;
          this.subject = null;
          if (!observers || observers.length === 0 || subject.isStopped || subject.closed) {
              return;
          }
          var subscriberIndex = observers.indexOf(this.subscriber);
          if (subscriberIndex !== -1) {
              observers.splice(subscriberIndex, 1);
          }
      };
      return SubjectSubscription;
  }(Subscription));

  /** PURE_IMPORTS_START tslib,_Observable,_Subscriber,_Subscription,_util_ObjectUnsubscribedError,_SubjectSubscription,_internal_symbol_rxSubscriber PURE_IMPORTS_END */
  var SubjectSubscriber = /*@__PURE__*/ (function (_super) {
      __extends(SubjectSubscriber, _super);
      function SubjectSubscriber(destination) {
          var _this = _super.call(this, destination) || this;
          _this.destination = destination;
          return _this;
      }
      return SubjectSubscriber;
  }(Subscriber));
  var Subject = /*@__PURE__*/ (function (_super) {
      __extends(Subject, _super);
      function Subject() {
          var _this = _super.call(this) || this;
          _this.observers = [];
          _this.closed = false;
          _this.isStopped = false;
          _this.hasError = false;
          _this.thrownError = null;
          return _this;
      }
      Subject.prototype[rxSubscriber] = function () {
          return new SubjectSubscriber(this);
      };
      Subject.prototype.lift = function (operator) {
          var subject = new AnonymousSubject(this, this);
          subject.operator = operator;
          return subject;
      };
      Subject.prototype.next = function (value) {
          if (this.closed) {
              throw new ObjectUnsubscribedError();
          }
          if (!this.isStopped) {
              var observers = this.observers;
              var len = observers.length;
              var copy = observers.slice();
              for (var i = 0; i < len; i++) {
                  copy[i].next(value);
              }
          }
      };
      Subject.prototype.error = function (err) {
          if (this.closed) {
              throw new ObjectUnsubscribedError();
          }
          this.hasError = true;
          this.thrownError = err;
          this.isStopped = true;
          var observers = this.observers;
          var len = observers.length;
          var copy = observers.slice();
          for (var i = 0; i < len; i++) {
              copy[i].error(err);
          }
          this.observers.length = 0;
      };
      Subject.prototype.complete = function () {
          if (this.closed) {
              throw new ObjectUnsubscribedError();
          }
          this.isStopped = true;
          var observers = this.observers;
          var len = observers.length;
          var copy = observers.slice();
          for (var i = 0; i < len; i++) {
              copy[i].complete();
          }
          this.observers.length = 0;
      };
      Subject.prototype.unsubscribe = function () {
          this.isStopped = true;
          this.closed = true;
          this.observers = null;
      };
      Subject.prototype._trySubscribe = function (subscriber) {
          if (this.closed) {
              throw new ObjectUnsubscribedError();
          }
          else {
              return _super.prototype._trySubscribe.call(this, subscriber);
          }
      };
      Subject.prototype._subscribe = function (subscriber) {
          if (this.closed) {
              throw new ObjectUnsubscribedError();
          }
          else if (this.hasError) {
              subscriber.error(this.thrownError);
              return Subscription.EMPTY;
          }
          else if (this.isStopped) {
              subscriber.complete();
              return Subscription.EMPTY;
          }
          else {
              this.observers.push(subscriber);
              return new SubjectSubscription(this, subscriber);
          }
      };
      Subject.prototype.asObservable = function () {
          var observable = new Observable();
          observable.source = this;
          return observable;
      };
      Subject.create = function (destination, source) {
          return new AnonymousSubject(destination, source);
      };
      return Subject;
  }(Observable));
  var AnonymousSubject = /*@__PURE__*/ (function (_super) {
      __extends(AnonymousSubject, _super);
      function AnonymousSubject(destination, source) {
          var _this = _super.call(this) || this;
          _this.destination = destination;
          _this.source = source;
          return _this;
      }
      AnonymousSubject.prototype.next = function (value) {
          var destination = this.destination;
          if (destination && destination.next) {
              destination.next(value);
          }
      };
      AnonymousSubject.prototype.error = function (err) {
          var destination = this.destination;
          if (destination && destination.error) {
              this.destination.error(err);
          }
      };
      AnonymousSubject.prototype.complete = function () {
          var destination = this.destination;
          if (destination && destination.complete) {
              this.destination.complete();
          }
      };
      AnonymousSubject.prototype._subscribe = function (subscriber) {
          var source = this.source;
          if (source) {
              return this.source.subscribe(subscriber);
          }
          else {
              return Subscription.EMPTY;
          }
      };
      return AnonymousSubject;
  }(Subject));

  /** PURE_IMPORTS_START tslib,_Subscriber,_Notification PURE_IMPORTS_END */
  var ObserveOnSubscriber = /*@__PURE__*/ (function (_super) {
      __extends(ObserveOnSubscriber, _super);
      function ObserveOnSubscriber(destination, scheduler, delay) {
          if (delay === void 0) {
              delay = 0;
          }
          var _this = _super.call(this, destination) || this;
          _this.scheduler = scheduler;
          _this.delay = delay;
          return _this;
      }
      ObserveOnSubscriber.dispatch = function (arg) {
          var notification = arg.notification, destination = arg.destination;
          notification.observe(destination);
          this.unsubscribe();
      };
      ObserveOnSubscriber.prototype.scheduleMessage = function (notification) {
          var destination = this.destination;
          destination.add(this.scheduler.schedule(ObserveOnSubscriber.dispatch, this.delay, new ObserveOnMessage(notification, this.destination)));
      };
      ObserveOnSubscriber.prototype._next = function (value) {
          this.scheduleMessage(Notification.createNext(value));
      };
      ObserveOnSubscriber.prototype._error = function (err) {
          this.scheduleMessage(Notification.createError(err));
          this.unsubscribe();
      };
      ObserveOnSubscriber.prototype._complete = function () {
          this.scheduleMessage(Notification.createComplete());
          this.unsubscribe();
      };
      return ObserveOnSubscriber;
  }(Subscriber));
  var ObserveOnMessage = /*@__PURE__*/ (function () {
      function ObserveOnMessage(notification, destination) {
          this.notification = notification;
          this.destination = destination;
      }
      return ObserveOnMessage;
  }());

  /** PURE_IMPORTS_START tslib,_AsyncAction PURE_IMPORTS_END */
  var QueueAction = /*@__PURE__*/ (function (_super) {
      __extends(QueueAction, _super);
      function QueueAction(scheduler, work) {
          var _this = _super.call(this, scheduler, work) || this;
          _this.scheduler = scheduler;
          _this.work = work;
          return _this;
      }
      QueueAction.prototype.schedule = function (state, delay) {
          if (delay === void 0) {
              delay = 0;
          }
          if (delay > 0) {
              return _super.prototype.schedule.call(this, state, delay);
          }
          this.delay = delay;
          this.state = state;
          this.scheduler.flush(this);
          return this;
      };
      QueueAction.prototype.execute = function (state, delay) {
          return (delay > 0 || this.closed) ?
              _super.prototype.execute.call(this, state, delay) :
              this._execute(state, delay);
      };
      QueueAction.prototype.requestAsyncId = function (scheduler, id, delay) {
          if (delay === void 0) {
              delay = 0;
          }
          if ((delay !== null && delay > 0) || (delay === null && this.delay > 0)) {
              return _super.prototype.requestAsyncId.call(this, scheduler, id, delay);
          }
          return scheduler.flush(this);
      };
      return QueueAction;
  }(AsyncAction));

  /** PURE_IMPORTS_START tslib,_AsyncScheduler PURE_IMPORTS_END */
  var QueueScheduler = /*@__PURE__*/ (function (_super) {
      __extends(QueueScheduler, _super);
      function QueueScheduler() {
          return _super !== null && _super.apply(this, arguments) || this;
      }
      return QueueScheduler;
  }(AsyncScheduler));

  /** PURE_IMPORTS_START _QueueAction,_QueueScheduler PURE_IMPORTS_END */
  var queueScheduler = /*@__PURE__*/ new QueueScheduler(QueueAction);
  var queue = queueScheduler;

  /** PURE_IMPORTS_START tslib,_Subject,_scheduler_queue,_Subscription,_operators_observeOn,_util_ObjectUnsubscribedError,_SubjectSubscription PURE_IMPORTS_END */
  var ReplaySubject = /*@__PURE__*/ (function (_super) {
      __extends(ReplaySubject, _super);
      function ReplaySubject(bufferSize, windowTime, scheduler) {
          if (bufferSize === void 0) {
              bufferSize = Number.POSITIVE_INFINITY;
          }
          if (windowTime === void 0) {
              windowTime = Number.POSITIVE_INFINITY;
          }
          var _this = _super.call(this) || this;
          _this.scheduler = scheduler;
          _this._events = [];
          _this._infiniteTimeWindow = false;
          _this._bufferSize = bufferSize < 1 ? 1 : bufferSize;
          _this._windowTime = windowTime < 1 ? 1 : windowTime;
          if (windowTime === Number.POSITIVE_INFINITY) {
              _this._infiniteTimeWindow = true;
              _this.next = _this.nextInfiniteTimeWindow;
          }
          else {
              _this.next = _this.nextTimeWindow;
          }
          return _this;
      }
      ReplaySubject.prototype.nextInfiniteTimeWindow = function (value) {
          if (!this.isStopped) {
              var _events = this._events;
              _events.push(value);
              if (_events.length > this._bufferSize) {
                  _events.shift();
              }
          }
          _super.prototype.next.call(this, value);
      };
      ReplaySubject.prototype.nextTimeWindow = function (value) {
          if (!this.isStopped) {
              this._events.push(new ReplayEvent(this._getNow(), value));
              this._trimBufferThenGetEvents();
          }
          _super.prototype.next.call(this, value);
      };
      ReplaySubject.prototype._subscribe = function (subscriber) {
          var _infiniteTimeWindow = this._infiniteTimeWindow;
          var _events = _infiniteTimeWindow ? this._events : this._trimBufferThenGetEvents();
          var scheduler = this.scheduler;
          var len = _events.length;
          var subscription;
          if (this.closed) {
              throw new ObjectUnsubscribedError();
          }
          else if (this.isStopped || this.hasError) {
              subscription = Subscription.EMPTY;
          }
          else {
              this.observers.push(subscriber);
              subscription = new SubjectSubscription(this, subscriber);
          }
          if (scheduler) {
              subscriber.add(subscriber = new ObserveOnSubscriber(subscriber, scheduler));
          }
          if (_infiniteTimeWindow) {
              for (var i = 0; i < len && !subscriber.closed; i++) {
                  subscriber.next(_events[i]);
              }
          }
          else {
              for (var i = 0; i < len && !subscriber.closed; i++) {
                  subscriber.next(_events[i].value);
              }
          }
          if (this.hasError) {
              subscriber.error(this.thrownError);
          }
          else if (this.isStopped) {
              subscriber.complete();
          }
          return subscription;
      };
      ReplaySubject.prototype._getNow = function () {
          return (this.scheduler || queue).now();
      };
      ReplaySubject.prototype._trimBufferThenGetEvents = function () {
          var now = this._getNow();
          var _bufferSize = this._bufferSize;
          var _windowTime = this._windowTime;
          var _events = this._events;
          var eventsCount = _events.length;
          var spliceCount = 0;
          while (spliceCount < eventsCount) {
              if ((now - _events[spliceCount].time) < _windowTime) {
                  break;
              }
              spliceCount++;
          }
          if (eventsCount > _bufferSize) {
              spliceCount = Math.max(spliceCount, eventsCount - _bufferSize);
          }
          if (spliceCount > 0) {
              _events.splice(0, spliceCount);
          }
          return _events;
      };
      return ReplaySubject;
  }(Subject));
  var ReplayEvent = /*@__PURE__*/ (function () {
      function ReplayEvent(time, value) {
          this.time = time;
          this.value = value;
      }
      return ReplayEvent;
  }());

  /** PURE_IMPORTS_START tslib,_Subject,_innerSubscribe PURE_IMPORTS_END */
  function retryWhen(notifier) {
      return function (source) { return source.lift(new RetryWhenOperator(notifier, source)); };
  }
  var RetryWhenOperator = /*@__PURE__*/ (function () {
      function RetryWhenOperator(notifier, source) {
          this.notifier = notifier;
          this.source = source;
      }
      RetryWhenOperator.prototype.call = function (subscriber, source) {
          return source.subscribe(new RetryWhenSubscriber(subscriber, this.notifier, this.source));
      };
      return RetryWhenOperator;
  }());
  var RetryWhenSubscriber = /*@__PURE__*/ (function (_super) {
      __extends(RetryWhenSubscriber, _super);
      function RetryWhenSubscriber(destination, notifier, source) {
          var _this = _super.call(this, destination) || this;
          _this.notifier = notifier;
          _this.source = source;
          return _this;
      }
      RetryWhenSubscriber.prototype.error = function (err) {
          if (!this.isStopped) {
              var errors = this.errors;
              var retries = this.retries;
              var retriesSubscription = this.retriesSubscription;
              if (!retries) {
                  errors = new Subject();
                  try {
                      var notifier = this.notifier;
                      retries = notifier(errors);
                  }
                  catch (e) {
                      return _super.prototype.error.call(this, e);
                  }
                  retriesSubscription = innerSubscribe(retries, new SimpleInnerSubscriber(this));
              }
              else {
                  this.errors = undefined;
                  this.retriesSubscription = undefined;
              }
              this._unsubscribeAndRecycle();
              this.errors = errors;
              this.retries = retries;
              this.retriesSubscription = retriesSubscription;
              errors.next(err);
          }
      };
      RetryWhenSubscriber.prototype._unsubscribe = function () {
          var _a = this, errors = _a.errors, retriesSubscription = _a.retriesSubscription;
          if (errors) {
              errors.unsubscribe();
              this.errors = undefined;
          }
          if (retriesSubscription) {
              retriesSubscription.unsubscribe();
              this.retriesSubscription = undefined;
          }
          this.retries = undefined;
      };
      RetryWhenSubscriber.prototype.notifyNext = function () {
          var _unsubscribe = this._unsubscribe;
          this._unsubscribe = null;
          this._unsubscribeAndRecycle();
          this._unsubscribe = _unsubscribe;
          this.source.subscribe(this);
      };
      return RetryWhenSubscriber;
  }(SimpleOuterSubscriber));

  /** PURE_IMPORTS_START _ReplaySubject PURE_IMPORTS_END */
  function shareReplay(configOrBufferSize, windowTime, scheduler) {
      var config;
      if (configOrBufferSize && typeof configOrBufferSize === 'object') {
          config = configOrBufferSize;
      }
      else {
          config = {
              bufferSize: configOrBufferSize,
              windowTime: windowTime,
              refCount: false,
              scheduler: scheduler,
          };
      }
      return function (source) { return source.lift(shareReplayOperator(config)); };
  }
  function shareReplayOperator(_a) {
      var _b = _a.bufferSize, bufferSize = _b === void 0 ? Number.POSITIVE_INFINITY : _b, _c = _a.windowTime, windowTime = _c === void 0 ? Number.POSITIVE_INFINITY : _c, useRefCount = _a.refCount, scheduler = _a.scheduler;
      var subject;
      var refCount = 0;
      var subscription;
      var hasError = false;
      var isComplete = false;
      return function shareReplayOperation(source) {
          refCount++;
          var innerSub;
          if (!subject || hasError) {
              hasError = false;
              subject = new ReplaySubject(bufferSize, windowTime, scheduler);
              innerSub = subject.subscribe(this);
              subscription = source.subscribe({
                  next: function (value) {
                      subject.next(value);
                  },
                  error: function (err) {
                      hasError = true;
                      subject.error(err);
                  },
                  complete: function () {
                      isComplete = true;
                      subscription = undefined;
                      subject.complete();
                  },
              });
              if (isComplete) {
                  subscription = undefined;
              }
          }
          else {
              innerSub = subject.subscribe(this);
          }
          this.add(function () {
              refCount--;
              innerSub.unsubscribe();
              innerSub = undefined;
              if (subscription && !isComplete && useRefCount && refCount === 0) {
                  subscription.unsubscribe();
                  subscription = undefined;
                  subject = undefined;
              }
          });
      };
  }

  /** PURE_IMPORTS_START tslib,_map,_observable_from,_innerSubscribe PURE_IMPORTS_END */
  function switchMap(project, resultSelector) {
      if (typeof resultSelector === 'function') {
          return function (source) { return source.pipe(switchMap(function (a, i) { return from(project(a, i)).pipe(map(function (b, ii) { return resultSelector(a, b, i, ii); })); })); };
      }
      return function (source) { return source.lift(new SwitchMapOperator(project)); };
  }
  var SwitchMapOperator = /*@__PURE__*/ (function () {
      function SwitchMapOperator(project) {
          this.project = project;
      }
      SwitchMapOperator.prototype.call = function (subscriber, source) {
          return source.subscribe(new SwitchMapSubscriber(subscriber, this.project));
      };
      return SwitchMapOperator;
  }());
  var SwitchMapSubscriber = /*@__PURE__*/ (function (_super) {
      __extends(SwitchMapSubscriber, _super);
      function SwitchMapSubscriber(destination, project) {
          var _this = _super.call(this, destination) || this;
          _this.project = project;
          _this.index = 0;
          return _this;
      }
      SwitchMapSubscriber.prototype._next = function (value) {
          var result;
          var index = this.index++;
          try {
              result = this.project(value, index);
          }
          catch (error) {
              this.destination.error(error);
              return;
          }
          this._innerSub(result);
      };
      SwitchMapSubscriber.prototype._innerSub = function (result) {
          var innerSubscription = this.innerSubscription;
          if (innerSubscription) {
              innerSubscription.unsubscribe();
          }
          var innerSubscriber = new SimpleInnerSubscriber(this);
          var destination = this.destination;
          destination.add(innerSubscriber);
          this.innerSubscription = innerSubscribe(result, innerSubscriber);
          if (this.innerSubscription !== innerSubscriber) {
              destination.add(this.innerSubscription);
          }
      };
      SwitchMapSubscriber.prototype._complete = function () {
          var innerSubscription = this.innerSubscription;
          if (!innerSubscription || innerSubscription.closed) {
              _super.prototype._complete.call(this);
          }
          this.unsubscribe();
      };
      SwitchMapSubscriber.prototype._unsubscribe = function () {
          this.innerSubscription = undefined;
      };
      SwitchMapSubscriber.prototype.notifyComplete = function () {
          this.innerSubscription = undefined;
          if (this.isStopped) {
              _super.prototype._complete.call(this);
          }
      };
      SwitchMapSubscriber.prototype.notifyNext = function (innerValue) {
          this.destination.next(innerValue);
      };
      return SwitchMapSubscriber;
  }(SimpleOuterSubscriber));

  /** PURE_IMPORTS_START tslib,_innerSubscribe PURE_IMPORTS_END */
  function takeUntil(notifier) {
      return function (source) { return source.lift(new TakeUntilOperator(notifier)); };
  }
  var TakeUntilOperator = /*@__PURE__*/ (function () {
      function TakeUntilOperator(notifier) {
          this.notifier = notifier;
      }
      TakeUntilOperator.prototype.call = function (subscriber, source) {
          var takeUntilSubscriber = new TakeUntilSubscriber(subscriber);
          var notifierSubscription = innerSubscribe(this.notifier, new SimpleInnerSubscriber(takeUntilSubscriber));
          if (notifierSubscription && !takeUntilSubscriber.seenValue) {
              takeUntilSubscriber.add(notifierSubscription);
              return source.subscribe(takeUntilSubscriber);
          }
          return takeUntilSubscriber;
      };
      return TakeUntilOperator;
  }());
  var TakeUntilSubscriber = /*@__PURE__*/ (function (_super) {
      __extends(TakeUntilSubscriber, _super);
      function TakeUntilSubscriber(destination) {
          var _this = _super.call(this, destination) || this;
          _this.seenValue = false;
          return _this;
      }
      TakeUntilSubscriber.prototype.notifyNext = function () {
          this.seenValue = true;
          this.complete();
      };
      TakeUntilSubscriber.prototype.notifyComplete = function () {
      };
      return TakeUntilSubscriber;
  }(SimpleOuterSubscriber));

  /** PURE_IMPORTS_START  PURE_IMPORTS_END */
  function noop() { }

  /** PURE_IMPORTS_START tslib,_Subscriber,_util_noop,_util_isFunction PURE_IMPORTS_END */
  function tap(nextOrObserver, error, complete) {
      return function tapOperatorFunction(source) {
          return source.lift(new DoOperator(nextOrObserver, error, complete));
      };
  }
  var DoOperator = /*@__PURE__*/ (function () {
      function DoOperator(nextOrObserver, error, complete) {
          this.nextOrObserver = nextOrObserver;
          this.error = error;
          this.complete = complete;
      }
      DoOperator.prototype.call = function (subscriber, source) {
          return source.subscribe(new TapSubscriber(subscriber, this.nextOrObserver, this.error, this.complete));
      };
      return DoOperator;
  }());
  var TapSubscriber = /*@__PURE__*/ (function (_super) {
      __extends(TapSubscriber, _super);
      function TapSubscriber(destination, observerOrNext, error, complete) {
          var _this = _super.call(this, destination) || this;
          _this._tapNext = noop;
          _this._tapError = noop;
          _this._tapComplete = noop;
          _this._tapError = error || noop;
          _this._tapComplete = complete || noop;
          if (isFunction(observerOrNext)) {
              _this._context = _this;
              _this._tapNext = observerOrNext;
          }
          else if (observerOrNext) {
              _this._context = observerOrNext;
              _this._tapNext = observerOrNext.next || noop;
              _this._tapError = observerOrNext.error || noop;
              _this._tapComplete = observerOrNext.complete || noop;
          }
          return _this;
      }
      TapSubscriber.prototype._next = function (value) {
          try {
              this._tapNext.call(this._context, value);
          }
          catch (err) {
              this.destination.error(err);
              return;
          }
          this.destination.next(value);
      };
      TapSubscriber.prototype._error = function (err) {
          try {
              this._tapError.call(this._context, err);
          }
          catch (err) {
              this.destination.error(err);
              return;
          }
          this.destination.error(err);
      };
      TapSubscriber.prototype._complete = function () {
          try {
              this._tapComplete.call(this._context);
          }
          catch (err) {
              this.destination.error(err);
              return;
          }
          return this.destination.complete();
      };
      return TapSubscriber;
  }(Subscriber));

  exports.ModuleUtils = void 0;

  (function (_ModuleUtils) {
    function isPromise(obj) {
      return !!obj && typeof obj.then === "function";
    }

    _ModuleUtils.isPromise = isPromise;

    function isSubscribable(obj) {
      return !!obj && typeof obj.subscribe === "function";
    }

    _ModuleUtils.isSubscribable = isSubscribable;
    _ModuleUtils.isObservable = isSubscribable;
  })(exports.ModuleUtils || (exports.ModuleUtils = {}));

  const generateUUID = () => {
    var d = new Date().getTime();
    var d2 = typeof performance !== "undefined" && performance.now && performance.now() * 1000 || 0;
    return "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, function (c) {
      var r = Math.random() * 16;

      if (d > 0) {
        r = (d + r) % 16 | 0;
        d = Math.floor(d / 16);
      } else {
        r = (d2 + r) % 16 | 0;
        d2 = Math.floor(d2 / 16);
      }

      return (c === "x" ? r : r & 0x3 | 0x8).toString(16);
    });
  };

  const getTypeOperation = processingType => {
    switch (processingType) {
      case "CONCAT":
        return concatMap;

      case "EXHAUST":
        return exhaustMap;

      case "MERGE":
        return mergeMap;

      case "SWITCH":
        return switchMap;

      default:
        return switchMap;
    }
  };
  class Execution {
    constructor(key) {
      this.key = key;
      this.state = {};
      this.onQueueTime = void 0;
      this.params = void 0;
      this.onProcessingTime = void 0;
      this.onCompleteTime = void 0;
      this.onCanceledTime = void 0;
      this._errors = [];
      this.index = -1;
      this.setWaiting = this.setWaiting.bind(this);
      this.setCanceled = this.setCanceled.bind(this);
      this.setProcessing = this.setProcessing.bind(this);
      this.setSuccess = this.setSuccess.bind(this);
      this.setError = this.setError.bind(this);
      this.setData = this.setData.bind(this);
      this.addError = this.addError.bind(this);
    }

    setWaiting(params, index) {
      this.params = params;
      this.state = {
        status: "WAITING"
      };
      this.onQueueTime = new Date();
      return this;
    }

    setCanceled(key) {
      this.key = key;
      this.state = {
        status: "CANCELED"
      };
      this.onCanceledTime = new Date();
      return this;
    }

    setProcessing() {
      this.onProcessingTime = new Date();
      this.state = _extends({}, this.state, {
        status: "PROCESSING"
      });
      return this;
    }

    setSuccess(data) {
      this.onCompleteTime = new Date();
      this.state = _extends({}, this.state, {
        data,
        status: "SUCCESS"
      });
      return this;
    }

    setError(error) {
      this.onCompleteTime = new Date();
      this.state = _extends({}, this.state, {
        error,
        status: "ERROR"
      });
      return this;
    }

    setData(data) {
      this.state = _extends({}, this.state, {
        data
      });
    }

    get isLoading() {
      return this.state.status === "PROCESSING";
    }

    get isError() {
      return this.state.status === "ERROR";
    }

    get isSuccess() {
      return this.state.status === "SUCCESS";
    }

    get isWaiting() {
      return this.state.status === "WAITING";
    }

    get isCanceled() {
      return this.state.status === "CANCELED";
    }

    get data() {
      return this.state.data;
    }

    get error() {
      return this.state.error;
    }

    get errors() {
      return this._errors;
    }

    get status() {
      return this.state.status;
    }

    addError(error) {
      this.errors.unshift(error);
    }

  }
  class RxConcurrentExecutor {
    execute(params) {
      const getKey = this.config.getKey;
      const key = getKey ? getKey(params) : generateUUID();
      const execution = new Execution(key); //TODO: asyncLock

      this.executions[key] = execution;
      this.execute$.next({
        key,
        params: params
      });
      return execution;
    }

    isLoading(key) {
      const execution = this._executions[key];

      if (!execution) {
        return;
      }

      return execution.isLoading;
    }

    isError(key) {
      const execution = this._executions[key];

      if (!execution) {
        return;
      }

      return execution.isError;
    }

    isSuccess(key) {
      const execution = this._executions[key];

      if (!execution) {
        return;
      }

      return execution.isSuccess;
    }

    data(key) {
      const execution = this._executions[key];

      if (!execution) {
        return;
      }

      return execution.state.data;
    }

    error(key) {
      const execution = this._executions[key];

      if (!execution) {
        return;
      }

      return execution.state.error;
    }

    errors(key) {
      const execution = this._executions[key];

      if (!execution) {
        return;
      }

      return execution.errors;
    }

    status(key) {
      const execution = this._executions[key];

      if (!execution) {
        return;
      }

      return execution.state.status;
    }

    retry(key) {
      const execution = this._executions[key];

      if (!execution) {
        return;
      }

      return this.execute(execution.params);
    }

    setData(key, data) {
      const execution = this._executions[key];

      if (!execution) {
        return;
      }

      let newData = data;

      if (typeof data === "function") {
        newData = data(execution.state.data);
      }

      execution.setData(newData);
      this.config.onExecutionChange && this.config.onExecutionChange(execution);
    }

    getExecution(key) {
      return this._executions[key];
    }

    get executions() {
      return this._executions;
    }

    static create(executeFn$, config) {
      return new RxConcurrentExecutor(executeFn$, config);
    }

    constructor(executeFn$, config) {
      this.executeFn$ = executeFn$;
      this.execute$ = new rxjs.Subject();
      this.internalDestroy$ = new rxjs.Subject();
      this.execution$ = void 0;
      this._executions = {};
      this.config = void 0;
      this.config = config || {};
      this.isLoading = this.isLoading.bind(this);
      this.execute = this.execute.bind(this);
      this.retry = this.retry.bind(this);
      this.isError = this.isError.bind(this);
      this.isSuccess = this.isSuccess.bind(this);
      this.data = this.data.bind(this);
      this.error = this.error.bind(this);
      this.errors = this.errors.bind(this);
      this.status = this.status.bind(this);
      this.setData = this.setData.bind(this);
      this.getExecution = this.getExecution.bind(this);
      const effectiveDestroy$ = this.config.destroy$ ? rxjs.merge(this.config.destroy$, this.internalDestroy$) : this.internalDestroy$;
      const execute$ = this.config.source$ ? rxjs.merge(this.config.source$.pipe(map(params => {
        const getKey = this.config.getKey;
        const key = getKey ? getKey(params) : generateUUID();
        return {
          key,
          params
        };
      }), tap(({
        key,
        params
      }) => {
        let execution = this._executions[key]; //TODO: asyncLock

        execution = new Execution(key);
        this._executions[key] = execution;
      })), this.execute$) : this.execute$;
      const asyncOperation = getTypeOperation(this.config.processingType);
      this.execution$ = execute$.pipe(takeUntil(effectiveDestroy$), map((execute, index) => {
        let execution = this._executions[execute.key];
        execution.setWaiting(execute.params, index);

        if (!!Object.keys(this.executions).map(key => this.executions[key]).find(execution => execution.state.status === "PROCESSING") && this.config.processingType === "EXHAUST") {
          execution.setCanceled(execute.key);
        }

        if (this.config.processingType === "SWITCH") {
          Object.keys(this.executions).map(key => this.executions[key]).filter(execution => execution.state.status === "PROCESSING").forEach(execution => {
            execution.setCanceled(execute.key);
          });
        }

        this.config.onExecutionChange && this.config.onExecutionChange(execution);
        return execution;
      }), tap(execution => {
        this.config.onQueuing && this.config.onQueuing(execution.params, execution.key, execution);
        this.config.onExecutionChange && this.config.onExecutionChange(execution);
      }), asyncOperation(execution => {
        const params = execution.params;
        const data$ = this.executeFn$ ? this.executeFn$(params) : rxjs.of(params).pipe(map(p => p));
        const loadData$ = exports.ModuleUtils.isObservable(data$) ? data$ : exports.ModuleUtils.isPromise(data$) ? rxjs.from(data$) : rxjs.of(data$);
        execution.setProcessing();
        this._executions[execution.key] = execution;
        const retryConfig = this.config.retry ? this.config.retry : {
          interval: 1000,
          maxRetryAttempts: 0
        };
        const maxRetryAttempts = retryConfig.maxRetryAttempts ? retryConfig.maxRetryAttempts : 0;
        const notRetryWhenStatus = retryConfig.notRetryWhenStatus ? retryConfig.notRetryWhenStatus : [];
        return rxjs.merge(rxjs.of(execution), loadData$.pipe(retryWhen(errors => errors.pipe(tap(e => {
          execution.addError(e);
        }), concatMap((e, i) => rxjs.iif(() => {
          if (i < maxRetryAttempts) {
            const responseStatus = (e || {}).status || 0;
            const notRetry = !!notRetryWhenStatus.find(status => status === responseStatus);

            if (notRetry) {
              return true;
            }

            if (retryConfig.noRetryWhen && retryConfig.noRetryWhen(e)) {
              return true;
            }

            return false;
          }

          return true;
        }, rxjs.throwError(() => e), rxjs.of(e).pipe(delay((retryConfig.typeInterval === "LINEAR" ? 1 : i) * retryConfig.interval)))))), map(data => execution.setSuccess(data))).pipe(catchError(error => rxjs.of(execution.setError(error)))));
      })).pipe(tap(execution => {
        execution.state.status === "WAITING" && this.config.onQueuing && this.config.onQueuing(execution.params, execution.key, execution);
        execution.state.status === "PROCESSING" && this.config.onProcessing && this.config.onProcessing(execution.params, execution.key, execution);
        execution.state.status === "SUCCESS" && this.config.onSuccess && this.config.onSuccess(execution.state.data, execution.params, execution.key, execution);
        execution.state.status === "ERROR" && this.config.onError && this.config.onError(execution.state.error, execution.params, execution.key, execution);
      }), delay(1), tap(execution => {
        this.config.onExecutionChange && this.config.onExecutionChange(execution);
      }));
    }

    init() {
      this.execution$.subscribe();
    }

    destroy() {
      this.internalDestroy$.next();
      this.internalDestroy$.complete();
    }

  }

  class RxExecutor {
    constructor(executeFn$, config) {
      this.executeFn$ = executeFn$;
      this.config = config;
      this.key = "---key---";
      this.concurrentExecutor = void 0;
      this.concurrentExecutor = RxConcurrentExecutor.create(executeFn$, _extends({}, config, {
        getKey: () => this.key
      }));
      this.execute = this.execute.bind(this);
      this.retry = this.retry.bind(this);
      this.setData = this.setData.bind(this);
    }

    static create(executeFn$, config) {
      return new RxExecutor(executeFn$, config);
    }

    get execution() {
      return this.concurrentExecutor.executions[this.key] || new Execution(this.key);
    }

    get isLoading() {
      return this.execution.state.status === "PROCESSING";
    }

    get isProcessing() {
      return this.execution.state.status === "PROCESSING";
    }

    get isError() {
      return this.execution.state.status === "PROCESSING";
    }

    get isSuccess() {
      return this.execution.state.status === "PROCESSING";
    }

    get data() {
      return this.execution.state.status === "PROCESSING";
    }

    get errors() {
      return this.execution.state.status === "PROCESSING";
    }

    get executions() {
      return this.concurrentExecutor.executions;
    }

    execute(params) {
      this.concurrentExecutor.execute(params);
    }

    retry() {
      this.concurrentExecutor.retry(this.key);
    }

    setData(data) {
      this.concurrentExecutor.setData(this.key, data);
    }

  }

  class MockServer {
    constructor(config) {
      this.config = config;
    }

    getConfig() {
      const responses = this.config.responses.map(response => {
        const ocurrence = response.ocurrence ? response.ocurrence : Math.random();
        const delay = response.delay ? response.delay : 0;
        const isError = !!response.isError;
        return _extends({}, response, {
          ocurrence,
          delay,
          isError
        });
      });
      const sum = responses.reduce((t, e) => t + e.ocurrence, 0);
      const ranges = responses.map(response => {
        return _extends({}, response, {
          percentil: Math.floor(response.ocurrence * 100 / sum)
        });
      }).reduce((t, e) => {
        const lastRange = t.length > 0 ? t[t.length - 1] : {
          top: 0,
          bottom: 0
        };
        return [...t, _extends({}, e, {
          top: lastRange.top + e.percentil,
          bottom: lastRange.top
        })];
      }, []);
      const randomValue = Math.floor(Math.random() * 100);
      return ranges.find(range => randomValue > range.bottom && randomValue <= range.top);
    }

    invoke() {
      return rxjs.of("").pipe(concatMap(_ => rxjs.of(this.getConfig())), take(1), delayWhen(config => {
        return rxjs.of(config.delay);
      }), concatMap(config => {
        const data$ = config.data();
        const loadData$ = exports.ModuleUtils.isObservable(data$) ? data$ : exports.ModuleUtils.isPromise(data$) ? rxjs.from(data$) : rxjs.of(data$);
        return rxjs.zip(loadData$, rxjs.of(config.isError));
      }), map(data => {
        if (data[1]) throw data[0];
        return data[0];
      }));
    }

  }

  MockServer.create = config => {
    return new MockServer(config);
  };

  function createCommonjsModule(fn, basedir, module) {
  	return module = {
  		path: basedir,
  		exports: {},
  		require: function (path, base) {
  			return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);
  		}
  	}, fn(module, module.exports), module.exports;
  }

  function commonjsRequire () {
  	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');
  }

  var objectHash_1 = createCommonjsModule(function (module, exports) {



  /**
   * Exported function
   *
   * Options:
   *
   *  - `algorithm` hash algo to be used by this instance: *'sha1', 'md5'
   *  - `excludeValues` {true|*false} hash object keys, values ignored
   *  - `encoding` hash encoding, supports 'buffer', '*hex', 'binary', 'base64'
   *  - `ignoreUnknown` {true|*false} ignore unknown object types
   *  - `replacer` optional function that replaces values before hashing
   *  - `respectFunctionProperties` {*true|false} consider function properties when hashing
   *  - `respectFunctionNames` {*true|false} consider 'name' property of functions for hashing
   *  - `respectType` {*true|false} Respect special properties (prototype, constructor)
   *    when hashing to distinguish between types
   *  - `unorderedArrays` {true|*false} Sort all arrays before hashing
   *  - `unorderedSets` {*true|false} Sort `Set` and `Map` instances before hashing
   *  * = default
   *
   * @param {object} object value to hash
   * @param {object} options hashing options
   * @return {string} hash value
   * @api public
   */
  exports = module.exports = objectHash;

  function objectHash(object, options){
    options = applyDefaults(object, options);

    return hash(object, options);
  }

  /**
   * Exported sugar methods
   *
   * @param {object} object value to hash
   * @return {string} hash value
   * @api public
   */
  exports.sha1 = function(object){
    return objectHash(object);
  };
  exports.keys = function(object){
    return objectHash(object, {excludeValues: true, algorithm: 'sha1', encoding: 'hex'});
  };
  exports.MD5 = function(object){
    return objectHash(object, {algorithm: 'md5', encoding: 'hex'});
  };
  exports.keysMD5 = function(object){
    return objectHash(object, {algorithm: 'md5', encoding: 'hex', excludeValues: true});
  };

  // Internals
  var hashes = crypto__default["default"].getHashes ? crypto__default["default"].getHashes().slice() : ['sha1', 'md5'];
  hashes.push('passthrough');
  var encodings = ['buffer', 'hex', 'binary', 'base64'];

  function applyDefaults(object, sourceOptions){
    sourceOptions = sourceOptions || {};

    // create a copy rather than mutating
    var options = {};
    options.algorithm = sourceOptions.algorithm || 'sha1';
    options.encoding = sourceOptions.encoding || 'hex';
    options.excludeValues = sourceOptions.excludeValues ? true : false;
    options.algorithm = options.algorithm.toLowerCase();
    options.encoding = options.encoding.toLowerCase();
    options.ignoreUnknown = sourceOptions.ignoreUnknown !== true ? false : true; // default to false
    options.respectType = sourceOptions.respectType === false ? false : true; // default to true
    options.respectFunctionNames = sourceOptions.respectFunctionNames === false ? false : true;
    options.respectFunctionProperties = sourceOptions.respectFunctionProperties === false ? false : true;
    options.unorderedArrays = sourceOptions.unorderedArrays !== true ? false : true; // default to false
    options.unorderedSets = sourceOptions.unorderedSets === false ? false : true; // default to false
    options.unorderedObjects = sourceOptions.unorderedObjects === false ? false : true; // default to true
    options.replacer = sourceOptions.replacer || undefined;
    options.excludeKeys = sourceOptions.excludeKeys || undefined;

    if(typeof object === 'undefined') {
      throw new Error('Object argument required.');
    }

    // if there is a case-insensitive match in the hashes list, accept it
    // (i.e. SHA256 for sha256)
    for (var i = 0; i < hashes.length; ++i) {
      if (hashes[i].toLowerCase() === options.algorithm.toLowerCase()) {
        options.algorithm = hashes[i];
      }
    }

    if(hashes.indexOf(options.algorithm) === -1){
      throw new Error('Algorithm "' + options.algorithm + '"  not supported. ' +
        'supported values: ' + hashes.join(', '));
    }

    if(encodings.indexOf(options.encoding) === -1 &&
       options.algorithm !== 'passthrough'){
      throw new Error('Encoding "' + options.encoding + '"  not supported. ' +
        'supported values: ' + encodings.join(', '));
    }

    return options;
  }

  /** Check if the given function is a native function */
  function isNativeFunction(f) {
    if ((typeof f) !== 'function') {
      return false;
    }
    var exp = /^function\s+\w*\s*\(\s*\)\s*{\s+\[native code\]\s+}$/i;
    return exp.exec(Function.prototype.toString.call(f)) != null;
  }

  function hash(object, options) {
    var hashingStream;

    if (options.algorithm !== 'passthrough') {
      hashingStream = crypto__default["default"].createHash(options.algorithm);
    } else {
      hashingStream = new PassThrough();
    }

    if (typeof hashingStream.write === 'undefined') {
      hashingStream.write = hashingStream.update;
      hashingStream.end   = hashingStream.update;
    }

    var hasher = typeHasher(options, hashingStream);
    hasher.dispatch(object);
    if (!hashingStream.update) {
      hashingStream.end('');
    }

    if (hashingStream.digest) {
      return hashingStream.digest(options.encoding === 'buffer' ? undefined : options.encoding);
    }

    var buf = hashingStream.read();
    if (options.encoding === 'buffer') {
      return buf;
    }

    return buf.toString(options.encoding);
  }

  /**
   * Expose streaming API
   *
   * @param {object} object  Value to serialize
   * @param {object} options  Options, as for hash()
   * @param {object} stream  A stream to write the serializiation to
   * @api public
   */
  exports.writeToStream = function(object, options, stream) {
    if (typeof stream === 'undefined') {
      stream = options;
      options = {};
    }

    options = applyDefaults(object, options);

    return typeHasher(options, stream).dispatch(object);
  };

  function typeHasher(options, writeTo, context){
    context = context || [];
    var write = function(str) {
      if (writeTo.update) {
        return writeTo.update(str, 'utf8');
      } else {
        return writeTo.write(str, 'utf8');
      }
    };

    return {
      dispatch: function(value){
        if (options.replacer) {
          value = options.replacer(value);
        }

        var type = typeof value;
        if (value === null) {
          type = 'null';
        }

        //console.log("[DEBUG] Dispatch: ", value, "->", type, " -> ", "_" + type);

        return this['_' + type](value);
      },
      _object: function(object) {
        var pattern = (/\[object (.*)\]/i);
        var objString = Object.prototype.toString.call(object);
        var objType = pattern.exec(objString);
        if (!objType) { // object type did not match [object ...]
          objType = 'unknown:[' + objString + ']';
        } else {
          objType = objType[1]; // take only the class name
        }

        objType = objType.toLowerCase();

        var objectNumber = null;

        if ((objectNumber = context.indexOf(object)) >= 0) {
          return this.dispatch('[CIRCULAR:' + objectNumber + ']');
        } else {
          context.push(object);
        }

        if (typeof Buffer !== 'undefined' && Buffer.isBuffer && Buffer.isBuffer(object)) {
          write('buffer:');
          return write(object);
        }

        if(objType !== 'object' && objType !== 'function' && objType !== 'asyncfunction') {
          if(this['_' + objType]) {
            this['_' + objType](object);
          } else if (options.ignoreUnknown) {
            return write('[' + objType + ']');
          } else {
            throw new Error('Unknown object type "' + objType + '"');
          }
        }else {
          var keys = Object.keys(object);
          if (options.unorderedObjects) {
            keys = keys.sort();
          }
          // Make sure to incorporate special properties, so
          // Types with different prototypes will produce
          // a different hash and objects derived from
          // different functions (`new Foo`, `new Bar`) will
          // produce different hashes.
          // We never do this for native functions since some
          // seem to break because of that.
          if (options.respectType !== false && !isNativeFunction(object)) {
            keys.splice(0, 0, 'prototype', '__proto__', 'constructor');
          }

          if (options.excludeKeys) {
            keys = keys.filter(function(key) { return !options.excludeKeys(key); });
          }

          write('object:' + keys.length + ':');
          var self = this;
          return keys.forEach(function(key){
            self.dispatch(key);
            write(':');
            if(!options.excludeValues) {
              self.dispatch(object[key]);
            }
            write(',');
          });
        }
      },
      _array: function(arr, unordered){
        unordered = typeof unordered !== 'undefined' ? unordered :
          options.unorderedArrays !== false; // default to options.unorderedArrays

        var self = this;
        write('array:' + arr.length + ':');
        if (!unordered || arr.length <= 1) {
          return arr.forEach(function(entry) {
            return self.dispatch(entry);
          });
        }

        // the unordered case is a little more complicated:
        // since there is no canonical ordering on objects,
        // i.e. {a:1} < {a:2} and {a:1} > {a:2} are both false,
        // we first serialize each entry using a PassThrough stream
        // before sorting.
        // also: we can’t use the same context array for all entries
        // since the order of hashing should *not* matter. instead,
        // we keep track of the additions to a copy of the context array
        // and add all of them to the global context array when we’re done
        var contextAdditions = [];
        var entries = arr.map(function(entry) {
          var strm = new PassThrough();
          var localContext = context.slice(); // make copy
          var hasher = typeHasher(options, strm, localContext);
          hasher.dispatch(entry);
          // take only what was added to localContext and append it to contextAdditions
          contextAdditions = contextAdditions.concat(localContext.slice(context.length));
          return strm.read().toString();
        });
        context = context.concat(contextAdditions);
        entries.sort();
        return this._array(entries, false);
      },
      _date: function(date){
        return write('date:' + date.toJSON());
      },
      _symbol: function(sym){
        return write('symbol:' + sym.toString());
      },
      _error: function(err){
        return write('error:' + err.toString());
      },
      _boolean: function(bool){
        return write('bool:' + bool.toString());
      },
      _string: function(string){
        write('string:' + string.length + ':');
        write(string.toString());
      },
      _function: function(fn){
        write('fn:');
        if (isNativeFunction(fn)) {
          this.dispatch('[native]');
        } else {
          this.dispatch(fn.toString());
        }

        if (options.respectFunctionNames !== false) {
          // Make sure we can still distinguish native functions
          // by their name, otherwise String and Function will
          // have the same hash
          this.dispatch("function-name:" + String(fn.name));
        }

        if (options.respectFunctionProperties) {
          this._object(fn);
        }
      },
      _number: function(number){
        return write('number:' + number.toString());
      },
      _xml: function(xml){
        return write('xml:' + xml.toString());
      },
      _null: function() {
        return write('Null');
      },
      _undefined: function() {
        return write('Undefined');
      },
      _regexp: function(regex){
        return write('regex:' + regex.toString());
      },
      _uint8array: function(arr){
        write('uint8array:');
        return this.dispatch(Array.prototype.slice.call(arr));
      },
      _uint8clampedarray: function(arr){
        write('uint8clampedarray:');
        return this.dispatch(Array.prototype.slice.call(arr));
      },
      _int8array: function(arr){
        write('int8array:');
        return this.dispatch(Array.prototype.slice.call(arr));
      },
      _uint16array: function(arr){
        write('uint16array:');
        return this.dispatch(Array.prototype.slice.call(arr));
      },
      _int16array: function(arr){
        write('int16array:');
        return this.dispatch(Array.prototype.slice.call(arr));
      },
      _uint32array: function(arr){
        write('uint32array:');
        return this.dispatch(Array.prototype.slice.call(arr));
      },
      _int32array: function(arr){
        write('int32array:');
        return this.dispatch(Array.prototype.slice.call(arr));
      },
      _float32array: function(arr){
        write('float32array:');
        return this.dispatch(Array.prototype.slice.call(arr));
      },
      _float64array: function(arr){
        write('float64array:');
        return this.dispatch(Array.prototype.slice.call(arr));
      },
      _arraybuffer: function(arr){
        write('arraybuffer:');
        return this.dispatch(new Uint8Array(arr));
      },
      _url: function(url) {
        return write('url:' + url.toString());
      },
      _map: function(map) {
        write('map:');
        var arr = Array.from(map);
        return this._array(arr, options.unorderedSets !== false);
      },
      _set: function(set) {
        write('set:');
        var arr = Array.from(set);
        return this._array(arr, options.unorderedSets !== false);
      },
      _file: function(file) {
        write('file:');
        return this.dispatch([file.name, file.size, file.type, file.lastModfied]);
      },
      _blob: function() {
        if (options.ignoreUnknown) {
          return write('[blob]');
        }

        throw Error('Hashing Blob objects is currently not supported\n' +
          '(see https://github.com/puleos/object-hash/issues/26)\n' +
          'Use "options.replacer" or "options.ignoreUnknown"\n');
      },
      _domwindow: function() { return write('domwindow'); },
      _bigint: function(number){
        return write('bigint:' + number.toString());
      },
      /* Node.js standard native objects */
      _process: function() { return write('process'); },
      _timer: function() { return write('timer'); },
      _pipe: function() { return write('pipe'); },
      _tcp: function() { return write('tcp'); },
      _udp: function() { return write('udp'); },
      _tty: function() { return write('tty'); },
      _statwatcher: function() { return write('statwatcher'); },
      _securecontext: function() { return write('securecontext'); },
      _connection: function() { return write('connection'); },
      _zlib: function() { return write('zlib'); },
      _context: function() { return write('context'); },
      _nodescript: function() { return write('nodescript'); },
      _httpparser: function() { return write('httpparser'); },
      _dataview: function() { return write('dataview'); },
      _signal: function() { return write('signal'); },
      _fsevent: function() { return write('fsevent'); },
      _tlswrap: function() { return write('tlswrap'); },
    };
  }

  // Mini-implementation of stream.PassThrough
  // We are far from having need for the full implementation, and we can
  // make assumptions like "many writes, then only one final read"
  // and we can ignore encoding specifics
  function PassThrough() {
    return {
      buf: '',

      write: function(b) {
        this.buf += b;
      },

      end: function(b) {
        this.buf += b;
      },

      read: function() {
        return this.buf;
      }
    };
  }
  });

  const generateUniqSerial = () => {
    return "xxxx-xxxx-xxx-xxxx".replace(/[x]/g, function (c) {
      var r = Math.random() * 16 | 0,
          v = c === "x" ? r : r & 0x3 | 0x8;
      return v.toString(16);
    });
  };

  class Execution2 {
    get state$() {
      const state$ = this._state$.asObservable().pipe(shareReplay());

      return state$;
    }

    constructor(params, config) {
      this.params = params;
      this.config = config;
      this.id = void 0;
      this.status = void 0;
      this.data = void 0;
      this.error = void 0;
      this.hashedParams = void 0;
      this._state$ = new rxjs.Subject();
      const conf = config || {
        cache: false,
        getId: () => generateUniqSerial()
      };
      this.hashedParams = conf.cache ? objectHash_1(params) : undefined;
      this.id = conf.getId ? conf.getId(params) : generateUniqSerial();
    }

    get state() {
      return this;
    }

    retrying() {
      this.status = "RETRYING";

      this._state$.next(this);

      this.status = "PROCESSING";

      this._state$.next(this);

      return this.state;
    }

    wait() {
      this.status = "WAITING";

      this._state$.next(this);

      return this.state;
    }

    processing() {
      this.status = "PROCESSING";

      this._state$.next(this);

      return this.state;
    }

    succeed(data) {
      this.data = data;
      this.status = "SUCCESS";

      this._state$.next(this);

      return this.state;
    }

    failed(error) {
      this.error = error;
      this.status = "FAILED";

      this._state$.next(this);

      return this.state;
    }

    cancelled() {
      this.status = "CANCELLED";

      this._state$.next(this);

      return this.state;
    }

    listen(callback) {
      this.state$.subscribe(callback);
    }

  }
  const getTypeOperation2 = processingType => {
    switch (processingType) {
      case "CONCAT":
        return concatMap;

      case "EXHAUST":
        return exhaustMap;

      case "MERGE":
        return mergeMap;

      case "SWITCH":
        return switchMap;

      default:
        return switchMap;
    }
  };
  class RxExecutor2 {
    get params() {
      return this._params;
    }

    get error() {
      return this._error;
    }

    get status() {
      return this._status;
    }

    get data() {
      return this._data;
    }

    get isLoading() {
      return this._status === "PROCESSING";
    }

    get isProcessing() {
      return this._status === "PROCESSING";
    }

    get isSuccess() {
      return this._status === "SUCCESS";
    }

    get isError() {
      return this._status === "FAILED";
    }

    retry() {
      return this.execute(this._params);
    }

    constructor(executeFn$, config) {
      var _tempConfig$concurren;

      this.executeFn$ = executeFn$;
      this.config = config;
      this._status = void 0;
      this._data = void 0;
      this._params = void 0;
      this._error = void 0;
      this._internalExecution$ = new rxjs.Subject();
      this.executionType = void 0;
      this.operationType = void 0;
      this.processorCapacity = 1;
      this.enableCache = false;
      this.concurrentDetailed = false;
      this._state$ = void 0;
      this.cachedData = {};
      this.cachedExecution = {};
      this._execution = void 0;
      this.processingExecutions = [];
      this.failedExecutions = [];
      this.executionType = config ? config.concurrent ? "CONCURRENT" : "SEQUENTIAL" : "SEQUENTIAL";
      const tempConfig = this.config || {
        sequential: "SWITCH",
        concurrent: {
          type: "SWITCH",
          mergeCapacity: 1,
          detailed: true
        },
        cache: false
      };
      this.concurrentDetailed = !!((_tempConfig$concurren = tempConfig.concurrent) != null && _tempConfig$concurren.detailed);
      const {
        concurrent,
        sequential
      } = tempConfig;
      this.operationType = sequential || concurrent && concurrent.type || "SWITCH";

      if (this.operationType === "MERGE" && tempConfig.concurrent.mergeCapacity > 1) {
        this.processorCapacity = tempConfig.concurrent.mergeCapacity;
      }

      this.enableCache = !!tempConfig.cache;
      this.execute = this.execute.bind(this);
      this.close = this.close.bind(this);
      this.getExecution = this.getExecution.bind(this);
      this._state$ = this.getState$();
      this.config = config || {};
    }

    get state$() {
      return this._state$;
    }

    close() {}

    static create(executeFn$, config) {
      return new RxExecutor2(executeFn$, config);
    }

    getExecution(id) {
      return this._execution;
    }

    execute(params, config) {
      const execution = this._execute(params, config);

      this._execution = execution;

      this._internalExecution$.next(execution);

      return execution;
    }

    _execute(params, config) {
      var _this$config, _this$config2;

      const context = (config ? config.context : {}) || {};

      const mergedContext = _extends({}, this.config && this.config.context || {}, context);

      if (this.executionType === "SEQUENTIAL" && this.operationType === "EXHAUST") {
        const currentxecution = this.processingExecutions[0];

        if (currentxecution) {
          return currentxecution;
        }
      }

      const execution = new Execution2(params, {
        executeFn$: config == null ? void 0 : config.executeFn$,
        cache: (_this$config = this.config) == null ? void 0 : _this$config.cache,
        getId: (_this$config2 = this.config) == null ? void 0 : _this$config2.getId,
        ignoreCache: config == null ? void 0 : config.ignoreCache
      });
      const ignoreCache = (config == null ? void 0 : config.ignoreCache) || false;
      const enableCache = this.enableCache && !ignoreCache;

      if (enableCache) {
        const key = objectHash_1(params);
        this.cachedExecution[key] = execution;
      }

      execution.state$.subscribe(exec => {
        if (this.executionType === "SEQUENTIAL") {
          if (this.operationType === "EXHAUST" || this.operationType === "SWITCH") {
            this._params = exec.params;
            this._status = exec.status;
            if (exec.status === "SUCCESS") this._data = exec.data;
            if (exec.status === "FAILED") this._error = exec.error;
          }
        }

        if (exec.status === "RETRYING") {
          config && config.onRetry && config.onRetry(exec.error, exec.params);
          this.config && this.config.onRetry && this.config.onRetry(exec.error, exec.params);
        }

        if (exec.status === "PROCESSING") {
          config && config.onProcessing && config.onProcessing(exec.params, mergedContext);
          this.config && this.config.onProcessing && this.config.onProcessing(exec.params, mergedContext);
        }

        if (exec.status === "SUCCESS") {
          config && config.onSuccess && config.onSuccess(exec.data, exec.params, mergedContext);
          this.config && this.config.onSuccess && this.config.onSuccess(exec.data, exec.params, mergedContext);
        }

        if (exec.status === "FAILED") {
          config && config.onError && config.onError(exec.error, exec.params, mergedContext);
          this.config && this.config.onError && this.config.onError(exec.error, exec.params, mergedContext);
        }

        if (exec.status === "WAITING") {
          config && config.onWait && config.onWait(exec.params, mergedContext);
          this.config && this.config.onWait && this.config.onWait(exec.params, mergedContext);
        }

        if (exec.status === "CANCELLED") {
          config && config.onCancel && config.onCancel(exec.params, mergedContext);
          this.config && this.config.onCancel && this.config.onCancel(exec.params, mergedContext);
        }
      });
      return execution;
    }

    invalidateCache(params) {
      const key = objectHash_1(params);
      const found = !!this.cachedData[key];
      delete this.cachedData[key];
      return found;
    }

    clearCache() {
      this.cachedData = {};
    }

    isFull() {
      return this.processingExecutions.length >= this.processorCapacity;
    }

    getState$() {
      const mergedExecutions$ = this.config && this.config.params$ ? rxjs.merge(this._internalExecution$, this.config.params$.pipe(map(params => this._execute(params)))) : this._internalExecution$;
      const asyncOperation = getTypeOperation2(this.operationType);
      const waitingSubject = new rxjs.Subject();
      const retrySubject = new rxjs.Subject();
      const retryConfig = this.config && this.config.retry ? this.config.retry : {
        interval: 1000,
        maxRetryAttempts: 0
      };
      const maxRetryAttempts = retryConfig.maxRetryAttempts ? retryConfig.maxRetryAttempts : 0;
      const notRetryWhenStatus = retryConfig.notRetryWhenStatus ? retryConfig.notRetryWhenStatus : [];
      return rxjs.merge(retrySubject.pipe(map(execution => {
        execution.retrying();
        return execution.state;
      })), waitingSubject.pipe(filter(() => {
        return this.operationType === "SWITCH" && this.executionType === "CONCURRENT";
      }), map(execution => {
        execution.wait();
        return execution.state;
      })), mergedExecutions$.pipe(tap(execution => {
        waitingSubject.next(execution);
      }), asyncOperation(execution => {
        var _execution$config, _execution$config2, _this$config3;

        const {
          params
        } = execution;
        const ignoreCache = ((_execution$config = execution.config) == null ? void 0 : _execution$config.ignoreCache) || false;
        const enableCache = this.enableCache && !ignoreCache;
        let cachedData = undefined;

        if (enableCache) {
          const key = objectHash_1(params);
          cachedData = this.cachedData[key];
        }

        const executeFn$ = ((_execution$config2 = execution.config) == null ? void 0 : _execution$config2.executeFn$) || this.executeFn$;
        const data$ = executeFn$ ? executeFn$(params) : rxjs.of(params).pipe(map(p => p));
        const loadData$ = enableCache && cachedData !== undefined ? rxjs.of(cachedData).pipe(delay(1)) : exports.ModuleUtils.isObservable(data$) ? data$ : exports.ModuleUtils.isPromise(data$) ? rxjs.from(data$) : rxjs.of(data$);
        const wrapData$ = (_this$config3 = this.config) != null && _this$config3.wrapData$ ? this.config.wrapData$(loadData$) : loadData$;
        return rxjs.merge(rxjs.of(execution).pipe(filter(() => {
          return this.operationType === "SWITCH" && this.executionType === "CONCURRENT" && this.isFull();
        }), map(() => {
          const execution = this.processingExecutions[0];
          execution.cancelled();
          return execution.state;
        })), rxjs.of(execution).pipe(filter(() => {
          return this.operationType !== "SWITCH" || this.executionType !== "SEQUENTIAL" || !this.isFull();
        }), tap(execution => {
          this.processingExecutions.push(execution);
        }), map(execution => {
          execution.processing();
          return execution.state;
        })), wrapData$.pipe(
        /*********************************************************/
        retryWhen(errors => errors.pipe(tap(e => {// execution.addError(e);
        }), concatMap((e, i) => rxjs.iif(() => {
          if (i < maxRetryAttempts) {
            const responseStatus = (e || {}).status || 0;
            const notRetry = !!notRetryWhenStatus.find(status => status === responseStatus);

            if (notRetry) {
              return true;
            }

            if (retryConfig.noRetryWhen && retryConfig.noRetryWhen(e)) {
              return true;
            }

            return false;
          }

          return true;
        }, rxjs.throwError(() => e), rxjs.of(e).pipe(tap(() => {
          retrySubject.next(execution);
        }), delay((retryConfig.typeInterval === "LINEAR" ? 1 : i) * retryConfig.interval)))))),
        /*********************************************************/
        map(resp => {
          execution.succeed(resp);
          return execution.state;
        }), tap(execution => {
          this.processingExecutions = this.processingExecutions.filter(e => e !== execution);

          if (this.enableCache) {
            this.cachedData[execution.hashedParams] = execution.data;
          }
        }, () => {
          this.processingExecutions = this.processingExecutions.filter(e => e !== execution);
        }), catchError(error => {
          execution.failed(error);
          return rxjs.of(execution.state);
        })));
      }))).pipe(shareReplay());
    }

  }

  exports.Execution = Execution;
  exports.Execution2 = Execution2;
  exports.MockServer = MockServer;
  exports.RxConcurrentExecutor = RxConcurrentExecutor;
  exports.RxExecutor = RxExecutor;
  exports.RxExecutor2 = RxExecutor2;
  exports.getTypeOperation = getTypeOperation;
  exports.getTypeOperation2 = getTypeOperation2;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
