import { IRxExecutorConfig, IRxExecuteFn } from ".";
import { Execution, RxConcurrentExecutor } from "./RxConcurrentExecutor";
export declare class RxExecutor<P = void, D = any> {
    protected executeFn$: IRxExecuteFn<P, D>;
    protected config?: IRxExecutorConfig<P, D> | undefined;
    key: string;
    concurrentExecutor: RxConcurrentExecutor<P, D>;
    constructor(executeFn$: IRxExecuteFn<P, D>, config?: IRxExecutorConfig<P, D> | undefined);
    static create<P, D>(executeFn$: IRxExecuteFn<P, D>, config?: IRxExecutorConfig<P, D>): RxExecutor<P, D>;
    get execution(): Execution<P, D>;
    get isLoading(): boolean;
    get isProcessing(): boolean;
    get isError(): boolean;
    get isSuccess(): boolean;
    get data(): boolean;
    get errors(): boolean;
    get executions(): {
        [key: string]: Execution<P, D>;
    };
    execute(params: P): void;
    retry(): void;
    setData(data: D | ((prev: D) => D)): void;
}
