"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.MockServer = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _rxjs = require("rxjs");

var _operators = require("rxjs/operators");

var _lang = require("../utils/lang");

class MockServer {
  constructor(config) {
    this.config = config;
  }

  getConfig() {
    const responses = this.config.responses.map(response => {
      const ocurrence = response.ocurrence ? response.ocurrence : Math.random();
      const delay = response.delay ? response.delay : 0;
      const isError = !!response.isError;
      return (0, _extends2.default)({}, response, {
        ocurrence,
        delay,
        isError
      });
    });
    const sum = responses.reduce((t, e) => t + e.ocurrence, 0);
    const ranges = responses.map(response => {
      return (0, _extends2.default)({}, response, {
        percentil: Math.floor(response.ocurrence * 100 / sum)
      });
    }).reduce((t, e) => {
      const lastRange = t.length > 0 ? t[t.length - 1] : {
        top: 0,
        bottom: 0
      };
      return [...t, (0, _extends2.default)({}, e, {
        top: lastRange.top + e.percentil,
        bottom: lastRange.top
      })];
    }, []);
    const randomValue = Math.floor(Math.random() * 100);
    return ranges.find(range => randomValue > range.bottom && randomValue <= range.top);
  }

  invoke() {
    return (0, _rxjs.of)("").pipe((0, _operators.concatMap)(_ => (0, _rxjs.of)(this.getConfig())), (0, _operators.take)(1), (0, _operators.delayWhen)(config => {
      return (0, _rxjs.of)(config.delay);
    }), (0, _operators.concatMap)(config => {
      const data$ = config.data();
      const loadData$ = _lang.ModuleUtils.isObservable(data$) ? data$ : _lang.ModuleUtils.isPromise(data$) ? (0, _rxjs.from)(data$) : (0, _rxjs.of)(data$);
      return (0, _rxjs.zip)(loadData$, (0, _rxjs.of)(config.isError));
    }), (0, _operators.map)(data => {
      if (data[1]) throw data[0];
      return data[0];
    }));
  }

}

exports.MockServer = MockServer;

MockServer.create = config => {
  return new MockServer(config);
};